//
//  GuideTimer.m
//  MoveCoachMobile
//
//  Created by Alex Morgan on 8/29/12.
//

#import "GuideTimer.h"
//#import "LocalNotification.h"

static GuideTimer *defaultStore = nil;

@implementation GuideTimer {
    
    //int oneWeek;
}

@synthesize guideTracker, chapterTracker, currentActiveChapter, oneWeek,aboutSMGDone, currentGuideBeingViewed;

+ (GuideTimer *)defaultStore
{
    if (defaultStore == nil) {
        NSArray *documentDirectories = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
        NSString *documentDirectory = [documentDirectories objectAtIndex:0];
        
        NSString *archivePath = [documentDirectory stringByAppendingPathComponent:@"guide.archive"];
        
        Boolean archiveExists = [[NSFileManager defaultManager] fileExistsAtPath:archivePath];
        
        if (archiveExists) {
            defaultStore = [[NSKeyedUnarchiver unarchiveObjectWithFile:archivePath] init];
        } else {
            defaultStore = [[super allocWithZone:nil] init];
        }
    }
    
    return defaultStore;
}

- (id)init {
    self = [super init];
    
    if (self) {
        
        if (!guideTracker) {
            NSMutableDictionary *guidesTemp = [[NSMutableDictionary alloc] initWithCapacity:11];

            //iterate thru to make Guide objects for all 11 guides, then add them to the guideTracker hash with their index as key and the guide object as the value
            for (int i=0; i<11; i++) {
                Guide *guide = [[Guide alloc] initWithIndex:i];
                [guidesTemp setObject:guide forKey:[NSNumber numberWithInt:i]];
            }        
            [self setGuideTracker:guidesTemp];

            //DATA TEST CONFIGS
//            if ([[LocalNotification notificationManager] testDataConfigIsOn]) {
//                oneWeek = 60;
//                
//            } else {
                oneWeek = 604800;
 //           }
            //[self setGuideDurations];
        }
        
        //chapter tracker
        if (!chapterTracker) {
            chapterTracker = [[NSMutableDictionary alloc] init];
        }
        
        if (!currentActiveChapter) {
            //set the first tablecell of the first guide as the active guide
            currentActiveChapter = @"100";
        }
        //set up the guide titles array.  This should really be pulled from a pList
        guideTitles = [NSArray arrayWithObjects:@"Getting Started",@"Tip the Balance",@"Getting Out",@"What's in Your Food?",@"Fit for Life",@"Trim the Fat",@"Play it Safe",@"Plan for Success",@"You are the Boss!",@"Taking Control",@"Keep it Going", nil];
        
    }
    return self;
}

/*+ (void) reset {
    defaultStore = nil;
}
*/
- (BOOL) areGuidesStarted {
    
    if (self.aboutSMGDone != YES) {
        return NO;
    }
    //Check if Guide 0 is active.  If so, then the guides are active.
    Guide *guideZero = [guideTracker objectForKey:[NSNumber numberWithInt:0]];
    return [guideZero isActive];
}


/*
 
 For the purposes of this method, Guides are described using their index from the tableView (here called guideIndex), which is zero referenced. so Guide numbering goes from 0-10, instead of the user perspective of 1-11. 
 
 */
- (BOOL)isGuideActive:(int)guideIndex
{
    BOOL isGuideActive = NO;
    
    NSNumber *guideKey = [NSNumber numberWithInt:guideIndex];    
    Guide *guide = [guideTracker objectForKey:guideKey];
    
    //if the guide is active, immediately return YES
    if ([guide isActive]) {
        isGuideActive = YES;
        
        //if this is guide zero, and the guide is not active, make it active
        //10/4 - Will need to modify here to confirm guide info has been read prior to unlocking guide 1
    }
    /*else if ([guideKey isEqualToNumber:[NSNumber numberWithInt:0]]) {
        
        if (aboutSMGDone) {
            if (![guide isActive]) {
                [guide setIsActive:YES];
                [guide setStartDate];
              //  [self createNotificationForGuide:2 withGuideName:[self getGuideTitleForIndex:guideIndex+1] withDate:[guide endDate]];
            }
            isGuideActive = YES;
        } else {
            isGuideActive = NO;
        }
        
        //this will handle guides 1-10, and the incoming guide is not active   
    } else {
        
        if ([self canGuideBeMadeActive:guideIndex]) {
            [guide setIsActive:YES];
            [guide setStartDate];
            isGuideActive = YES;
            
//            if (guideIndex < 10) {
//                [self createNotificationForGuide:guideIndex + 2 withGuideName:[self getGuideTitleForIndex:guideIndex+1] withDate:[guide endDate]];
//            }
        }
    }
    */
    return isGuideActive;
}

/*- (void) createNotificationForCurrentGuide {
    
    int currentGuideNumber = [self getCurrentActiveGuide];
    if (currentGuideNumber >= 0 && currentGuideNumber < 10) {
        NSNumber *guideKey = [NSNumber numberWithInt:currentGuideNumber];
        Guide *currentGuide = [guideTracker objectForKey:guideKey];
        
        [self createNotificationForGuide:currentGuideNumber+2 withGuideName:[self getGuideTitleForIndex:currentGuideNumber+1] withDate:[currentGuide endDate]];
    }
}
*/
/*- (void) createNotificationForGuide:(int)guideNumber withGuideName:(NSString *)guideName withDate:(NSDate *)date {
    
 //   NSString *notificationID = [NSString stringWithFormat:@"guideNotification%d", guideNumber];
    
//    if ([[LocalNotification notificationManager] guideNotificationsOn]) {
//        [[LocalNotification notificationManager] addNotificationForGuide:guideNumber withGuideName:guideName withDate:date withID:notificationID];
//    }
}
*/

- (int) getCurrentActiveGuide {
    
    int guideNumber = 0;
    
    if (![self areGuidesStarted]) {
        guideNumber = -1;
    } else {
        
        for (int i=10; i > 0; i--) {
            if ([self isGuideActive:i]) {
                guideNumber = i;
                break;
            }
        }
    }
    return guideNumber;
}

/*- (BOOL) canGuideBeMadeActive:(int)guideIndex {
    
    //this should never happen
    if (guideIndex < 1 || guideIndex > 10) {
        return NO;
    }
    
    //Get instances of the Guides we need to work with
    __unused Guide *currentGuide = [guideTracker objectForKey:[NSNumber numberWithInt:guideIndex]];
    Guide *previousGuide = [guideTracker objectForKey:[NSNumber numberWithInt:guideIndex - 1]];
    
    //end date of previous guide is not set, return NO
    if (![previousGuide endDate]) {
        return NO;
        
    } else {
        //end date of previous guide is set, need to check duration of previous and compare with NOW   
        
        //Get the time interval in seconds between previous end date and NOW.  if timeInterval is 0 or negative, then return YES, otherwise not enough time has passed
        NSTimeInterval timeSincePreviousGuideEndDate = [[previousGuide endDate] timeIntervalSinceNow];
        
        if (timeSincePreviousGuideEndDate <= 0) {
            return YES;
        }
    }
    
    return NO; 
}
*/
/*
- (BOOL)isGuideComplete:(int)guideIndex
{
    Guide *currentGuide = [guideTracker objectForKey:[NSNumber numberWithInt:guideIndex]];
    
    if ([currentGuide isComplete]) {
        if (!currentGuide.currentSummary) {
            [currentGuide summarizeGuide];
        }
        return YES;
    }
    
    if (![currentGuide endDate]) {
        return NO;
    }else {
        NSDate *today = [NSDate date];
        if ([today compare:[currentGuide endDate]] == NSOrderedDescending) {
            if (!currentGuide.currentSummary) {
                [currentGuide summarizeGuide];
            }
            [currentGuide setIsComplete:YES];
            return YES;
        }
    }
    return NO;
}
*/
/*- (void)showAlert:(int)guideIndex
{
    NSString *title;
    NSString *message;
    
    if (guideIndex == 0) {
        title = [NSString stringWithFormat:@"Guide 1 'Getting Started' is not active yet"];
        message = [NSString stringWithFormat:@"You must complete 'About Self Management Guides' first"];
    }else{
    
    Guide *previousGuide = [guideTracker objectForKey:[NSNumber numberWithInt:guideIndex-1]];
    
    
    if ([previousGuide isActive]) {
        //display start date
        NSDateFormatter *dateFormat = [[NSDateFormatter alloc]init];
        [dateFormat setDateStyle:NSDateFormatterLongStyle];
        
        NSDate *nextGuideStartDate = [previousGuide endDate];
        NSString *nextDate = [NSString stringWithFormat:@"%@",[dateFormat stringFromDate:nextGuideStartDate]];
        
        
        title = [NSString stringWithFormat:@"Guide %d '%@' is not active yet",guideIndex+1,[guideTitles objectAtIndex:(guideIndex)]];
        message = [NSString stringWithFormat:@"You must complete Guide %d '%@' and start this guide on %@.", guideIndex,[guideTitles objectAtIndex:guideIndex-1], nextDate];
        
    }else{
        //display previous guide number
        title = [NSString stringWithFormat:@"Guide %d '%@' is not active yet",guideIndex+1,[guideTitles objectAtIndex:(guideIndex)]];
        message = [NSString stringWithFormat:@"You must complete Guide %d '%@' first",guideIndex,[guideTitles objectAtIndex:guideIndex-1]];
    }
    }
    
    UIAlertView *inactiveContentAlert;
    
    if (UIAccessibilityIsVoiceOverRunning()) {
        inactiveContentAlert = [[UIAlertView alloc]initWithTitle:nil message:nil delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [inactiveContentAlert setIsAccessibilityElement:YES];
        [inactiveContentAlert setAccessibilityLabel:[NSString stringWithFormat:@"%@. %@. Double tap to accept.", title, message]];

    } else {
        inactiveContentAlert = [[UIAlertView alloc]initWithTitle:title message:message delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
    }
    
    [inactiveContentAlert show];
}

*/
- (NSString *) getGuideTitleForIndex:(int)index {
    
    return [guideTitles objectAtIndex:index];
    
}

//this method will set an entry in the data structure for this specific guide/chapter.

/*- (void) setChapterAsCompleteForGuide:(NSString *)guideChapterKey andNextChapter:(NSString *)nextChapterKey{
    
    
    //set the current chapter as active so it will be highlighted
    [chapterTracker setObject:@"complete" forKey:guideChapterKey];
    
    currentActiveChapter = guideChapterKey;

  */
    /*
     If it is decided that users will be forced to go through the guides in order, this is setup to set the 'next' chapter as the active chapter.  For now we are not using that
     */
/*    [chapterTracker setObject:@"complete" forKey:guideChapterKey];
    if (nextChapterKey) {
        NSString *status = [chapterTracker objectForKey:nextChapterKey];
        if (!([status isEqualToString:@"complete"])) {
            
            //make any that are active back to default
            
            NSDictionary *tempDictionary = [NSDictionary dictionaryWithDictionary:chapterTracker];
            for (NSString *key in tempDictionary) {
                
                NSString *status = [chapterTracker objectForKey:key];
                if ([status isEqualToString:@"active"]) {
                    //remove the 
                    [chapterTracker removeObjectForKey:key];
                }
            }
            [chapterTracker setObject:@"active" forKey:nextChapterKey];

        }
    }
 */
    
    
    
//}

//This method will query a data structure to detemine if a specific chapter within a guide has been completed.
- (BOOL)isChapterCompleteInGuide:(NSString *)guideChapterKey {
    
    NSString *status = [chapterTracker objectForKey:guideChapterKey];
    
    if ([status isEqualToString:@"complete"]) {
        
        return YES;
    }
    
    return NO;
}

//This method will query a data structure to determine if a specific chapter within a guide has been completed.
- (BOOL)isChapterActiveInGuide:(NSString *)guideChapterKey {
    
    if ([guideChapterKey isEqualToString:currentActiveChapter]) {
        return YES;
    }
    
    return NO;
}

- (NSString *) guideArchivePath {
    
    NSArray *documentDirectories = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentDirectory = [documentDirectories objectAtIndex:0];
    
    return [documentDirectory stringByAppendingPathComponent:@"guide.archive"];
}

/*- (void)encodeWithCoder:(NSCoder *)aCoder {
    [aCoder encodeObject:guideTracker forKey:@"guideTracker"];
    [aCoder encodeObject:chapterTracker forKey:@"chapterTracker"];
    [aCoder encodeObject:currentActiveChapter forKey:@"currentActiveChapter"];
    [aCoder encodeBool:aboutSMGDone forKey:@"aboutSMGDone"];
}
*/

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];
    
    if (self) {
        [self setGuideTracker:[aDecoder decodeObjectForKey:@"guideTracker"]];
        [self setChapterTracker:[aDecoder decodeObjectForKey:@"chapterTracker"]];
        [self setCurrentActiveChapter:[aDecoder decodeObjectForKey:@"currentActiveChapter"]];
        [self setAboutSMGDone:[aDecoder decodeBoolForKey:@"aboutSMGDone"]];
    }
    return self;
}

/*- (BOOL) saveChanges {
    
    NSLog(@"SAVING GUIDES DATA");
    
    NSString *archivePath = [self guideArchivePath];
    return [NSKeyedArchiver archiveRootObject:self toFile:archivePath];
}
*/
/**
 *  This is a method that will reset the existing list of Guides that have start and end dates.  The end date will be modified based on the value of the oneWeek variable.  This allows us to toggle between test and prod data.
 *
 */
/*- (void) setGuideDurations {
    
    NSDictionary *tempDictionary = guideTracker;
    for (int i=0; i<[tempDictionary count]; i++) {
        Guide *guide = [tempDictionary objectForKey:[NSNumber numberWithInt:i]];

        if ([guide startDate]) {
            [guide setEndDate:[NSDate dateWithTimeInterval:oneWeek * guide.duration sinceDate:guide.startDate]];
            
            [guideTracker removeObjectForKey:[NSNumber numberWithInt:i]];
            [guideTracker setObject:guide forKey:[NSNumber numberWithInt:i]];
        }
    }
}
*/
/*- (void)restartChapters {
    NSArray *keys = [chapterTracker allKeys];
    
    for (NSString *key in keys) {
        [chapterTracker setObject:@"" forKey:key];
    }
}
*/
//- (BOOL)restartGuides {
//    BOOL result = NO;
//    
//    NSDictionary *tracker = guideTracker;
//    
//    //This method can only procede if all Guides are complete for the current pass
//    if ([self isGuideComplete:10]) {
//        for (int i=0; i<[tracker count]; i++) {
//            Guide *guide = [tracker objectForKey:[NSNumber numberWithInt:i]];
//            guide.startDate = nil;
//            guide.endDate = nil;
//            guide.isActive = NO;
//            guide.isComplete = NO;
//            guide.currentSummary = nil;
//        }
//        [self restartChapters];
//        result = YES;
//    }
//    return result;
//}
@end
