//
//  MCM_Keyboard_Plugin.m
//  Move!Coach
//
//  Created by Morgan, Alex (Bay Pines) on 6/17/15.
//
//

#import "MCM_Keyboard_Plugin.h"
#import <UIKit/UIKit.h>
//#import <Cordova/NSDictionary+Extensions.h>
//#import <Cordova/NSArray+Comparisons.h>

@implementation MCM_Keyboard_Plugin
{
    CDVTextField *textFieldOut;
    NSString* tfCallback;
}

@synthesize hasPendingOperation;

-(void) showTextFieldWithCoord:(NSArray*)coordinates size:(NSArray*)widthAndHeight currentValue:(NSString*)currentValue placeholderText:(NSString*)placeholder keyboardType:(NSString*)keyboardType callbackID:(NSString*)callbackId
{
    textFieldOut = nil;
    textFieldOut = [[CDVTextField alloc]init];
    
    textFieldOut.callbackId = callbackId;
    
    
    //    [textFieldOut setFrame:CGRectMake(10, 10, 250, 45)];
    

    [textFieldOut setFrame:CGRectMake([[coordinates objectAtIndex:0]integerValue], [[coordinates objectAtIndex:1] integerValue], [[widthAndHeight objectAtIndex:0]integerValue], [[widthAndHeight objectAtIndex:1]integerValue])];
    
    
    
    
    if ([keyboardType isEqualToString:@"default"]) {
        [textFieldOut setKeyboardType:UIKeyboardTypeDefault];
    }else if([keyboardType isEqualToString:@"Alphabet"]){
        textFieldOut.keyboardType = UIKeyboardTypeAlphabet;
    }else if([keyboardType isEqualToString:@"ASCII"]){
        textFieldOut.keyboardType = UIKeyboardTypeASCIICapable;
    }else if([keyboardType isEqualToString:@"Decimal"]){
        textFieldOut.keyboardType = UIKeyboardTypeDecimalPad;
    }else if([keyboardType isEqualToString:@"Email"]){
        textFieldOut.keyboardType = UIKeyboardTypeEmailAddress;
    }else if([keyboardType isEqualToString:@"NamePhone"]){
        textFieldOut.keyboardType = UIKeyboardTypeNamePhonePad;
    }else if([keyboardType isEqualToString:@"Number"]){
        textFieldOut.keyboardType = UIKeyboardTypeNumberPad;
    }else if([keyboardType isEqualToString:@"NumPunc"]){
        textFieldOut.keyboardType = UIKeyboardTypeNumbersAndPunctuation;
    }else if([keyboardType isEqualToString:@"Phone"]){
        textFieldOut.keyboardType = UIKeyboardTypePhonePad;
    }else if([keyboardType isEqualToString:@"Twitter"]){
        textFieldOut.keyboardType = UIKeyboardTypeTwitter;
    }else if([keyboardType isEqualToString:@"URL"]){
        textFieldOut.keyboardType = UIKeyboardTypeURL;
    }else if([keyboardType isEqualToString:@"Web"]){
        textFieldOut.keyboardType = UIKeyboardTypeWebSearch;
    }else{
        textFieldOut.keyboardType = UIKeyboardTypeDefault;
    }
    
    [textFieldOut setPlaceholder:placeholder];
    [textFieldOut setText:currentValue];
    
    [textFieldOut setClearsOnInsertion:YES];
    
    
    [textFieldOut addTarget:self action:@selector(textViewEdited:) forControlEvents:UIControlEventEditingChanged];
    //    [textFieldOut addTarget:self action:@selector(textViewEdited:) forControlEvents:UIControlEventEditingDidEnd];
    
    
    [self.viewController.view addSubview:textFieldOut];
    
    [textFieldOut becomeFirstResponder];
    
}

-(void)openKeyboard:(CDVInvokedUrlCommand *)command
{
    //    [self.commandDelegate runInBackground:^{
    //gets callbackId
    NSString* callbackId = command.callbackId;
    
    //gets arguments
    NSArray* coords = [command argumentAtIndex:0];
    NSArray* sizes = [command argumentAtIndex:1];
    
    NSString* currentValue = [command argumentAtIndex:2];
    NSString* placeholder = [command argumentAtIndex:3];
    
    NSString* keyType = [command argumentAtIndex:4];
    //    }];
    [self showTextFieldWithCoord:coords size:sizes currentValue:currentValue placeholderText:placeholder keyboardType:keyType callbackID:callbackId];
    
    
    
}

-(void)cordovaGetEnteredValues:(CDVInvokedUrlCommand *)command
{
    // Retrieve the date String from the file via a utility method
    NSString *dateStr = [textFieldOut text];
    
    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:dateStr];
    
    // Execute sendPluginResult on this plugin's commandDelegate, passing in the instance of CDVPluginResult
    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
}


- (IBAction)textViewEdited:(id)sender {
    
    [self.commandDelegate runInBackground:^{
        
        CDVPluginResult *result = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:[textFieldOut text]];
        [result setKeepCallbackAsBool:YES];
        
        [self.commandDelegate sendPluginResult:result callbackId:textFieldOut.callbackId];
    }];
    
}


@end

@implementation CDVTextField

@synthesize callbackId;

@end

