//
//  StepData.h
//  MoveCoachMobile
//
//  Created by Alex Morgan on 8/21/13.
//

#import <Foundation/Foundation.h>


/**
 *  This Class is part of the Data Model and represents a single instance of a users steps taken.  The UserData Class maintains an array of StepData objects to provide a history of user steps
 */

@interface StepData : NSObject<NSCoding>

/**
 *  This property represents the date the step entry was entered into the system
 */
@property (nonatomic, strong)NSString *dateStepsCreated;

/**
 *  This property represents the number of steps entered into the system
 */
@property (nonatomic)float numberOfSteps;

/**
 *  This method allows a stepData object to be created with a specific date.
 *
 *  @param steps - The user's entered number of steps
 *
 *  @dateCreated - a specific date to set dateCreated to.
 */
- (id)initWithNumberOfSteps:(float)steps dateCreated:(NSString*)dateCreated;

@end
