//
//  Utilities.m
//  MoveCoachMobile
//
//  Created by Stephen Barrs on 12/19/12.
//

#import "Utilities.h"
//#import "GuideTimer.h"

//#import "NSString+sentenceCase.h"

#define kVIDEO_URL_PLIST @"videoUrls"
#define kHTML_URL_PLIST @"htmlUrls"

static Utilities *defaultUtilities = nil;
static NSDateFormatter *dateFormatter = nil;


@implementation Utilities

//@synthesize eventStore;

+ (Utilities *) defaultUtilities {
    
    if (defaultUtilities == nil) {
        defaultUtilities = [[super allocWithZone:nil] init];
        
    }
    if (dateFormatter == nil) {
        dateFormatter = [[NSDateFormatter alloc]init];
    }

    return defaultUtilities;
}

//This method will detemine what the next valid table cell is for tableview, so we can set it to active in the data store
/* currently Unused
- (NSString *) getNextValidIndexPathKey:(NSIndexPath *)indexPath withTableView:(UITableView *)tableView forGuide:(int)guideNumber {
 
    NSIndexPath *newIndexPath;
    UITableViewCell *newCell;
    
    int currentSection = [indexPath section];
    int currentRow = [indexPath row];
    
    newIndexPath = [NSIndexPath indexPathForRow:currentRow+1 inSection:currentSection];
    newCell = [tableView cellForRowAtIndexPath:newIndexPath];
    if (newCell) {
        return [NSString stringWithFormat:@"%d%d%d", guideNumber, [newIndexPath section], [newIndexPath row]];
    }
    
    newIndexPath = [NSIndexPath indexPathForRow:0 inSection:currentSection+1];
    newCell = [tableView cellForRowAtIndexPath:newIndexPath];
    if (newCell) {
        return [NSString stringWithFormat:@"%d%d%d", guideNumber, [newIndexPath section], [newIndexPath row]];
        
    }
    return nil;

    
    
}
*/

- (void) setCellAccessory:(UITableView *)tableView withCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath forGuide:(int)guideNumber {
    
 //   NSString *chapterKey = [NSString stringWithFormat:@"%d%d%d", guideNumber, [indexPath section], [indexPath row]];
    
 //   BOOL chapterComplete = [[GuideTimer defaultStore] isChapterCompleteInGuide:chapterKey];
 //   BOOL chapterActive = [[GuideTimer defaultStore] isChapterActiveInGuide:chapterKey];
    
    // if statement to determine image state
//    if (chapterComplete) {
//        
//        //create check mark image
//        UIImage *image = [UIImage imageNamed:@"checkMarkSlate"];
//        UIImageView *checkMarkImage = [[UIImageView alloc]initWithImage:image];
//        [cell setAccessoryView:nil];
//        [cell setAccessoryType:UITableViewCellAccessoryNone];
//        [cell setAccessoryView:checkMarkImage];
//        
//        [cell setAccessibilityLabel:[NSString stringWithFormat:@"%@, is complete", [[cell textLabel] text]]];
//    } else {
//        [cell setAccessoryView:nil];
//        [cell setAccessoryType:UITableViewCellAccessoryDisclosureIndicator];
//        [cell setAccessibilityLabel:[[cell textLabel] text]];
//
//    }

//    if (chapterActive) {
//        [cell setAccessoryView:nil];
//
//        if (floor(NSFoundationVersionNumber) <= NSFoundationVersionNumber_iOS_6_1) {
//            [cell setHighlighted:YES animated:YES];
//        } else {
//            UIView *bgColorView = [[UIView alloc] init];
//            bgColorView.backgroundColor = [UIColor colorWithRed:(76.0/255.0) green:(161.0/255.0) blue:(255.0/255.0) alpha:1.0]; // perfect color suggested by @mohamadHafez
//            bgColorView.layer.masksToBounds = YES;
//            cell.selectedBackgroundView = bgColorView;
//            [cell setHighlighted:YES];
//        }
//        
//        [cell setAccessibilityLabel:[NSString stringWithFormat:@"%@, is the currently active chapter", [[cell textLabel] text]]];
//        
//        if (chapterComplete) {
//            
//            //create check mark image
//            UIImage *image = [UIImage imageNamed:@"checkMarkWhite"];
//            UIImageView *checkMarkImage = [[UIImageView alloc]initWithImage:image];
//            [cell setAccessoryType:UITableViewCellAccessoryNone];
//            [cell setAccessoryView:checkMarkImage];
//            
//            [cell setAccessibilityLabel:[NSString stringWithFormat:@"%@, is the last chapter completed", [[cell textLabel] text]]];
//        }
//    }
}


- (UILabel *) createCustomHeaderForNavigationItem:(NSString *)title withAccessibilityLabel:(NSString *)label {
    
    UILabel *titleLabel = [[UILabel alloc] init];
    titleLabel.text = title;
    [titleLabel setAccessibilityLabel:label];
    [titleLabel setFont:[UIFont boldSystemFontOfSize:20.0]];
    [titleLabel setBackgroundColor:[UIColor clearColor]];
    if ([[[UIDevice currentDevice]systemVersion]floatValue]<7) {
        [titleLabel setTextColor:[UIColor whiteColor]];
    }else{
        [titleLabel setTextColor:[UIColor darkTextColor]];
    }
    
    [titleLabel sizeToFit];
    
    [titleLabel setAccessibilityTraits:UIAccessibilityTraitHeader];

    return titleLabel;
}



//Computational methods - arithmetic & date/time

- (float)floatInRangeMin: (int)min andMax: (int)max
{
    if (min > max) {
        return -1;
    }
    
    int adjustedMax = (max + 1) - min;
    
    // arc4random returns within the set {min, (max - 1)}
    int random = arc4random() % adjustedMax;
    int result = random + min;
    
    return (float)result;
}

- (BOOL)isSameDay: (NSDate*)date0 as: (NSDate*)date1
{
    NSCalendar* calendar = [NSCalendar currentCalendar];
    int differenceInDays = [calendar ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate: date1] - [calendar ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate: date0];
    return (differenceInDays == 0);
}

- (NSDateFormatter *)getDateFormatter
{
    return dateFormatter;
}

- (float) calculateBMIGivenWeight: (float)weight andHeight: (float)height
{
    float bmi = ((weight / (height * height))*703.0);
    if (isnan(bmi) || isinf(bmi)) {
        return 0.0;
    }
    return bmi;
}

//- (BOOL) isVeteran {
//    
//    BOOL isAVeteran = YES;
//    
//    
//    return isAVeteran;
//}


- (NSDate *) getDateConfiguredAsKey:(NSDate *)date {
    
    //get the objects date and configure to use as key into dictionary
    NSDateComponents* comps = [[NSCalendar currentCalendar] components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:date];
    [comps setHour:00];
    [comps setMinute:00];
    [comps setSecond:01];
    NSDate *keyDate = [[NSCalendar currentCalendar] dateFromComponents:comps];
    
    return keyDate;
}

- (NSString *) removeAllCapsFromString:(NSString *)allCapsString {
    
 //   return [allCapsString realSentenceCapitalizedString];
}


- (void)listSubviewsOfView:(UIView *)view addBorder:(BOOL)border{
    
    // Get the subviews of the view
    NSArray *subviews = [view subviews];
    
    // Return if there are no subviews
    if ([subviews count] == 0) return;
    
    for (UIView *subview in subviews) {
        
        // Do what you want to do with the subview

        if (border) {
            subview.layer.borderColor = [UIColor redColor].CGColor;
            subview.layer.borderWidth = 1.0;
        }
        // List the subviews of subview
        [self listSubviewsOfView:subview addBorder:border];
    }
}


- (UIView *) createFooterViewWithDoneButtonForViewController:(UIViewController *)viewController {
    
    UIView *footerView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 50)];
    [footerView setBackgroundColor:[UIColor clearColor]];
    
    UIButton *doneBtn = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    [doneBtn setFrame:CGRectMake(234, 3, 66, 44)];
    
    [doneBtn setTitle:@"Done" forState:UIControlStateNormal];
    
    UIFont* boldFont = [UIFont boldSystemFontOfSize:15.0];
    [[doneBtn titleLabel] setFont:boldFont];
    
    UIColor *textColor;
    UIColor *backgroundColor;
    if ([[[UIDevice currentDevice]systemVersion]floatValue]<7) {
        backgroundColor = [UIColor clearColor];
        textColor = [UIColor colorWithRed:0.22 green:0.33 blue:0.53 alpha:1.0];
    } else {
        backgroundColor = [UIColor whiteColor];
        textColor = [UIColor colorWithRed:0.0 green:122.0/255.0 blue:1.0 alpha:1.0];
    }
    
    [doneBtn setTitleColor:textColor forState:UIControlStateNormal];
    [doneBtn setBackgroundColor:backgroundColor];
    
    [doneBtn setAccessibilityLabel:@"Done"];
    [doneBtn setAccessibilityHint:@"Double tap to submit your answers and return to the Guide."];
    [doneBtn setAccessibilityTraits:UIAccessibilityTraitButton];
    
    [footerView addSubview:doneBtn];
    [doneBtn addTarget:viewController action:@selector(doneButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
    
    
    return footerView;
    
}

- (int)daysBetween:(NSDate *)dt1 and:(NSDate *)dt2 {
    NSUInteger unitFlags = NSDayCalendarUnit;
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *components = [calendar components:unitFlags fromDate:dt1 toDate:dt2 options:0];
    return [components day]+1;
}

- (UIColor *)getColorForBMI:(float)bmi {
    UIColor *color = nil;
    
    if (bmi >= 40.0) {
        color = [UIColor colorWithRed:231.0f/255.0f green:21.0f/255.0f blue:28.0f/255.0f alpha:1];
    } else if (bmi >= 35.0) {
        color = [UIColor colorWithRed:242/255.0 green:124/255.0 blue:24/255.0 alpha:1];
    } else if (bmi >= 30.0) {
        color = [UIColor colorWithRed:250/255.0 green:177/255.0 blue:109/255.0 alpha:1];
    } else if (bmi >= 25) {
        color = [UIColor colorWithRed:254/255.0 green:231/255.0 blue:152/255.0 alpha:1];
    } else if (bmi >= 18.5) {
        color = [UIColor colorWithRed:158/255.0 green:206/255.0 blue:120/255.0 alpha:1];
    } else {
        color = [UIColor colorWithRed:198/255.0 green:219/255.0 blue:233/255.0 alpha:1];
    }

    return color;
}


- (UIColor *) getBreakfastColor {
    return [UIColor colorWithRed:0.522 green:0.757 blue:0.961 alpha:1];
}
- (UIColor *) getLunchColor {
    return [UIColor colorWithRed:0.957 green:0.729 blue:0.439 alpha:1];
}
- (UIColor *) getDinnerColor {
    return [UIColor colorWithRed:0.914 green:0.427 blue:0.388 alpha:1];
}
- (UIColor *) getSnacksColor {
    return [UIColor colorWithRed:0.498 green:0.792 blue:0.624 alpha:1];
}


@end
