define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        CalendarModel = require("models/CalendarEventModel"),
        template = require("text!templates/dietaryGoals.html");

    var compiled_template = Handlebars.compile(template);
    
    var mcmCalendar = null;
	var calEventTitle = "MOVE!Coach Diet Goal Check";
	var calEventNotes = "movecoachmobile://dietGoalEvent";

    
	var DietaryGoalsView = Backbone.View.extend({
        id: "dietaryGoalsView",

         events: {
              "change #dsg1": "saveGoalData",
              "change #dsg2": "saveGoalData",
              "focusout #dsgcid": "createCheckinEvent",
              "focusin #dsgcid": "findCheckinEvent"
         },

		initialize: function() {
			console.log ("initializing dietary goals view: " + this);
		},
		
		render: function() {
			log.debug ("calling render in dietary goals view");
        	
            this.$el.html(compiled_template(this.model.toJSON()));
            return this;
		},
		
		saveGoalData: function() {
			var textValue = this.$('#dsg1').val();
            UserData.set("dietSmartGoal1", textValue);
			textValue = this.$('#dsg2').val();
            UserData.set("dietSmartGoal2", textValue);
            UserData.save();
		}, 
		
		findCheckinEvent: function() {
			console.log("diet goals view findCheckinEvent");
			var textValue = this.$('#dsgcid').val();
			console.log("for : " + textValue);
			
			mcmCalendar = new CalendarModel(calEventTitle, calEventNotes);
			mcmCalendar.findEvent(textValue);
			
			this.$('#dsgcid').val( mcmCalendar.suggestFutureDate(textValue) );

			console.log("diet goals view findCheckinEvent finished");
		}, 
		
		createCheckinEvent: function() {
			console.log("diet goals view createCheckinEvent");
			var textValue = this.$('#dsgcid').val();
            UserData.set("dietGoalsCheckinDate", textValue);
            UserData.save();
            console.log("userdata saved - checkin date: " + textValue);

			mcmCalendar.createEvent(textValue);
			
			console.log("diet goals view createCheckinEvent finished");
		}
	});
	return DietaryGoalsView;
});