define(function(require) {
    var log = require("loglevel"),
        UserData = require("models/UserData"),
        eula_template = require("text!templates/eula.html");

    var EulaView = Backbone.View.extend({
        id: "eulaView",

        template: eula_template,

        events: {
            "click #accept-button": "handleAcceptButton"
        },

        render: function() {
            this.$el.html(eula_template);
            return this;
        },

        handleAcceptButton: function() {
            // Save flag to local storage...
            UserData.set("isEulaComplete", true);
            UserData.save();

            // Navigate to main view.
            mainRouter.navigate("#", {
                trigger: true
            });
        }
    });

    return EulaView;
});
