define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        NutritionData = require("models/NutritionData"),
        PortionData = require("models/PortionData"),
        template = require("text!templates/FoodListTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var dateEntered;

	var PortionArray = [];
	var NutritionArray = [];
	
	var entriesArray = [];
	var favArray = [];
	
	var favorite = false;

    var wtArray = UserData.get("currentWeight");


    var FoodListView = Backbone.View.extend({
        id: "FoodListView",

        templateName: "FoodListTemplate.html",

           events: {
            
            "click #addBreakfast": function(ev) {this.selectedMeal("Breakfast");},
            "click #addLunch": function(ev) {this.selectedMeal("Lunch");},
            "click #addDinner": function(ev) {this.selectedMeal("Dinner");},
            "click #addSnack": function(ev) {this.selectedMeal("Snack");},
            'click li#selectableCells a#favSelect':'favTappedInList',
            'click li#selectableCells a#itemSelect':'itemTappedInList'

           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);

		},

		render: function() {
			log.debug ("calling render in foodList view with template name: " + this.templateName);

        	this.$el.html(template);
            
            
            entriesArray = PortionData.get("DietEntrys");
            
            var currentDate = UserData.get("entryDate").toDateString();
            
            var breakfastCalories = 0,
            lunchCalories = 0,
            dinnerCalories = 0,
            snackCalories = 0;
            
            var html="";
            
            
            favArray = NutritionData.get("foodFavorites");
            
            
           for (var i=0;i<entriesArray.length; i++){
            	
            	
            	if(currentDate == entriesArray[i].date){
            		
            		var isFav = false;
            		
            		for(var j=0;j < favArray.length; j++){
            			if(entriesArray[i].foodname == favArray[j].foodname){
            				isFav = true;
            			}
            			
            		}
            		
            		if(isFav == true){
            			html = '<li id="selectableCells" data-masterArrayIndex="'+i+'" style="white-space:normal;" class="ui-btn-icon-right ui-icon-carat-r"><a id="itemSelect" href="#addDiet" data-masterArrayIndex="'+i+'"><p style="font-size: 14px; white-space:normal;"><b>' + entriesArray[i].foodname + "</b><br /><span style='font-size:12px; white-space:normal;'>" + entriesArray[i].servings + " " + entriesArray[i].servingSize + "<br/>" + entriesArray[i].calories.toFixed(0) +  ' Calories</span></p></a><a id="favSelect" data-favState="true" data-favIndex="'+i+'" class="ui-alt-icon"></a></li>';
            			
            		}else{
            			html = '<li id="selectableCells" data-masterArrayIndex="'+i+'" style="white-space:normal;" class="ui-btn-icon-right ui-icon-carat-r"><a id="itemSelect" href="#addDiet" data-masterArrayIndex="'+i+'"><p style="font-size:14px; white-space:normal;"><b>' + entriesArray[i].foodname + "</b><br /><span style='font-size:12px; white-space:normal;'>" + entriesArray[i].servings + " " + entriesArray[i].servingSize + "<br/>" + entriesArray[i].calories.toFixed(0) +  ' Calories</span></p></a><a id="favSelect" data-favState="false" data-favIndex="'+i+'"></a></li>';

            		}
            		
            		
            		if(entriesArray[i].meal == "Breakfast"){

            			this.$("#addBreakfast").after(html);
            			breakfastCalories = Number(breakfastCalories) + Number(entriesArray[i].calories);
            		}
            		
            		if(entriesArray[i].meal == "Lunch"){

            			this.$("#addLunch").after(html);
            			lunchCalories = Number(lunchCalories) + Number(entriesArray[i].calories);
            		}
            		
            		if(entriesArray[i].meal == "Dinner"){

            			this.$("#addDinner").after(html);
            			dinnerCalories = Number(dinnerCalories) + Number(entriesArray[i].calories);
            		}
            		
            		if(entriesArray[i].meal == "Snack"){
   			
            			this.$("#addSnack").after(html);
            			snackCalories = Number(snackCalories) + Number(entriesArray[i].calories);
            		}
            	
            	}
            }
            
            this.$("#breakfastCalories").html(breakfastCalories.toFixed(0));
            this.$("#lunchCalories").html(lunchCalories.toFixed(0));
            this.$("#dinnerCalories").html(dinnerCalories.toFixed(0));
            this.$("#snackCalories").html(snackCalories.toFixed(0));
            
            var totalFoodCalories = Number(breakfastCalories) + Number(lunchCalories) + Number(dinnerCalories) + Number(snackCalories); 
            
            UserData.set('foodCalories', totalFoodCalories);
            UserData.save();


            return this;
		},
        getIndex: function(ev){

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index() - 1;

        	console.log("selected index: " + selected_index);


        },
        refreshList: function(){

        	console.log('refresh');
        	
        	this.$('#foodList').listview('refresh');

        	
        },
		selectedMeal: function(meal){
			
			UserData.set('selectedMeal', meal);
			UserData.save();			
			
		
		},
		favTappedInList:function(ev){
			
			
			favorite = false;
			
			for(var i=0;i < favArray.length;i++){
				if(entriesArray[$(ev.currentTarget).attr("data-favIndex")].foodname === favArray[i].foodname){
					favorite = true;
				}
			}
			
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(entriesArray[$(ev.currentTarget).attr("data-favIndex")].foodname === favArray[i].foodname){
        		favorite = false;
        		favArray.splice(i,1);
        	}
        }
				
			}else{
					
				favArray[favArray.length]={
					foodcode: entriesArray[$(ev.currentTarget).attr("data-favIndex")].foodcode, 
                	foodname: entriesArray[$(ev.currentTarget).attr("data-favIndex")].foodname,
                	energy: entriesArray[$(ev.currentTarget).attr("data-favIndex")].energy
				};
				favorite = true;
				
			}
			
			favorite = false;
			
			NutritionData.set("foodFavorites",favArray);
			NutritionData.save();
			
			this.render();
			
			$('body').enhanceWithin();
			
		},
		itemTappedInList:function(ev){
			
			
			console.log(JSON.stringify(entriesArray[$(ev.currentTarget).attr("data-masterArrayIndex")]));
			console.log($(ev.currentTarget).attr("data-masterArrayIndex"));
			UserData.set("isEditing", true);
			UserData.set("editingObject",entriesArray[$(ev.currentTarget).attr("data-masterArrayIndex")]);
			UserData.set("editIndex",$(ev.currentTarget).attr("data-masterArrayIndex"));
			
			UserData.save();
			
		}
    
    });

    return FoodListView;
});
