define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        template = require("text!templates/G4C4HungerSlider.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var value1 = 5;
    // The view for Guide 1 Quesionnaire
    var G4GetReadyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g4C4HungerSliderView",


        events: {
            'click #surveyComplete': 'storeSurveyData',
            'change #slider-1': 'slider1change'


        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            value1 = 5;

            var message = "5 - We call this neutral.  You aren't hungry and you aren't full.  Your body feels content";


            this.$('#hungerText').replaceWith('<p id="hungerText" style="margin-left: auto; margin-right: auto;width: 100%">' + message + '</p>');
            // this.$('#slider-1').replaceWith('')

            return this;
        },
        slider1change: function() {
        	var value = this.$('#slider-1').val();

        	var message = "5 - We call this neutral.  You aren't hungry and you aren't full.  Your body feels content";

        	if (value == 1){
        		message = "1 - You are light-headed, dizzy, feeling extreamly uncomfortable.  Get something to eat, FAST!  And, try not to let yourself go this long without nourishing your body.";
        	}else if(value == 2){
        		message = "2 - You're feeling uncomfortable like you could eat everything in sight.  You're very hungry and it might be causing you to feel anxious or irritable.";
        	}else if(value == 3){
        		message = "3 - You are experiencing clear signals that it is time to eat!  You are not yet uncomfortable, but you might want to consider having somthing to eat soon.";
        	}else if(value == 4){
        		message = "4 - Slightly hungry.  You might feel mild signals that your body needs food, but you can still wait to eat.";
        	}else if(value == 5){
        		message = "5 - We call this neutral.  You aren't hungry and you aren't full.  Your body feels content.";
        	}else if(value == 6){
        		message = "6 - You are starting to feel full.  You are still comfortable, but could stand to eat a few more bites.";
        	}else if(value == 7){
        		message = '7 - This is ideal fullness.  You are not stuffed or starving.  You are "just right!"';
        	}else if(value == 8){
        		message = "8 - You are on the high side of an acceptable comfort range.  You might be a little too full and you really should not go beyond this fullness.";
        	}else if(value == 9){
        		message = "9 - You are a little fuller than you should be!  Your pants might feel like they need to be unbuttoned.  To avoid the uncomfortable feeling you're experiencing, try putting down the fork a few times throughout your meal to determine how full you are getting.";
        	}else if(value == 10){
        		message = '10 - uh oh!  Looks like you ate too much.  This is what we call "Thanksgiving full".' + "  You don't need to feel uncomfortable or sickly after meals.  for your next meal, try to time yourself while eating.  Set an alarm for 20 minutes and eat mindfully so that you are around a 7.";
        	}

        	this.$('#hungerText').replaceWith('<p id="hungerText" style="margin-left: auto; margin-right: auto;width: 100%">' + message + '</p>');
        }
    });

    return G4GetReadyView;
});
