define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G5C1ActivitySliders.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var value1;
	var value2;
    var value3;
    var value4;
	var value5;
    var value6;
    var value6a;
	var value7;
    var value8;

    // The view for Guide 1 Quesionnaire
    var G5C1ActivitySlidersView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g5C1ActivitySlidersView",


        events: {
            'click #slidersComplete': 'generateReport',
            'change #slider-1': 'slider1change',
            'change #slider-2': 'slider2change',
            'change #slider-3': 'slider3change',
            'change #slider-4': 'slider4change',
            'change #slider-5': 'slider5change',
            'change #slider-6': 'slider6change',
            'change #slider-7': 'slider7change',
            'change #slider-8': 'slider8change',
            'click #test-data-button': 'populateTestData',
            "click #previous-button": "handlePreviousButton"
        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));
            // $(this.el).attr('data-role', 'page');

            value1 = 0;
            value2 = 0;
            value3 = 0;
            value4 = 0;
            value5 = 0;
            value6 = 0;
            value6a = 0;
            value7 = 0;
            value8 = 0;

			$('#next-button').replaceWith('<div id="next-button"></div>');

            return this;
        },
        slider1change: function() {
        	value1 = this.$('#slider-1').val();
        	this.$('#sleepText').replaceWith('<span id="sleepText">' + value1 + '</span>');
        },
        slider2change: function() {
        	value2 = this.$('#slider-2').val();
        	this.$('#inactiveText').replaceWith('<span id="inactiveText">' + value2 + '</span>');
        },
        slider3change: function() {
        	value3 = this.$('#slider-3').val();
        	this.$('#leisureText').replaceWith('<span id="leisureText">' + value3 + '</span>');
        },
        slider4change: function() {
        	value4 = this.$('#slider-4').val();
        	this.$('#strengthText').replaceWith('<span id="strengthText">' + value4 + '</span>');
        },
        slider5change: function() {
        	value5 = this.$('#slider-5').val();
        	this.$('#flexText').replaceWith('<span id="flexText">' + value5 + '</span>');
        },
        slider6change: function() {
        	value6 = this.$('#slider-6').val();
        	this.$('#aerobicMinText').replaceWith('<span id="aerobicMinText">' + value6 + '</span>');
        	value6a = Number(value6) * Number(value7);
        	this.$('#aerobicMinPerWeekText').replaceWith('<span id="aerobicMinPerWeekText">' + value6a + '</span>');
        },
        slider7change: function() {
        	value7 = this.$('#slider-7').val();
        	this.$('#aerobicDaysText').replaceWith('<span id="aerobicDaysText">' + value7 + '</span>');
        	value6a = Number(value6) * Number(value7);
        	this.$('#aerobicMinPerWeekText').replaceWith('<span id="aerobicMinPerWeekText">' + value6a + '</span>');
        },
        slider8change: function() {
        	value8 = this.$('#slider-8').val();
        	this.$('#everydayText').replaceWith('<span id="everydayText">' + value8 + '</span>');
        },

        generateReport: function() {
            // Save changes to local storage.

            this.$('#viewReport').replaceWith('<div id="viewReport"></div>');
            this.$('#localFooter').replaceWith('<div id="localFooter"></div>');

            var message = "Your activities:\n" + value1 + " hours of sleep per day\n" + value4 + " Strength Training Days per Week\n" + value5 + " Flexibility Days per Week\n" + value6a + " Aerobic & Recreational Minutes per Week\n" + value3 + " Leisure hours per week\n" + value8 + " Everyday hours per week\n" + value2 + " Sedintary hours per week\n\nMOVE! Recommends the following:\n8 hours of sleep per day\n2 - 3 Strength Training Days\n3+ Flexibility Days\n300+ Aerobic & Recreational Minutes\nGet as much as possible Leisure and Everyday activities\nSpend as little time as possible on Sedentary activities.";

            // var HTMLmessage = "<p>Your plate was filled by:<br />" + value1 + "% Vegetables & Fruit<br />" + value2 + "% Grains & Starchy Vegetables<br />" + value3 + "% Lean Meat & Other Proteins<br /><br />MOVE! Recommends the following:<br />50% Vegetables & Fruit<br />25% Grains & Starchy Vegetables<br />25% Lean Meat & Other Proteins";

            // this.$('#viewReport').replaceWith('<div id="viewReport">' + HTMLmessage + '</div>');


          /*  message = '<table><tr><td></td><td>Your Activities</td><td>MOVE! Recommends</td></tr>\
                    <tr><td>Sleep (hours)</td><td align=\"center\">' + value1 + '</td><td align=\"center\">56</td></tr>\
                    <tr><td>Strength (days)</td><td align=\"center\"> + value4 + </td><td align=\"center\">2 - 3</td></tr>\
                    <tr><td>Flexibility (days)</td><td align=\"center\">' + value5 + '</td><td align=\"center\">3+</td></tr>\
                    <tr><td>Aerobic & Recreational (minutes)</td><td align=\"center\">' + value6a + '</td><td align=\"center\">300+</td></tr>\
                    <tr><td>Leisure (hours)</td><td align=\"center\">' + value3 + '</td><td>As much as possible</td></tr>\
                    <tr><td>Everyday (hours)</td><td align=\"center\">' + value8 + '</td><td>As much as possible</td></tr>\
                    <tr><td>Sedentary (hours)</td><td align=\"center\">' + value2 + '</td><td>As little as possible</td></tr>\
                    </table>';
            */

            // alert(message);


				navigator.notification.alert(
                message,    // message
                null,       // callback
                "Your Activity Report", // title
                'OK'        // buttonName
            );


        }
    });

    return G5C1ActivitySlidersView;
});
