define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        GuidesCollection = require("collections/allGuides"),
        template = require("text!templates/guideSummaries.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for all the self-management guides
    var GuideSummariesView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "GuideSummariesView",

		initialize: function(args) {

			Handlebars.registerHelper('showProgressReview', function(guideId) {

				if (guideId == 7 || guideId == 11) {

					var checkin = '<li class="smallListItem" ><a href="#progressReview/' + guideId + '" >' ;
                    checkin += '<img src="images/icons/app_icon@2x.png" /><h2>Guide ' + guideId + ' Progress Check-In</h2></a></li>';
    			  	return new Handlebars.SafeString(checkin);
				}
			});
		},

        render: function() {

            this.$el.html(compiled_template(GuidesCollection.toJSON()));
            return this;
        }
    });

    return GuideSummariesView;
});
