define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData");
        template = require("text!templates/home.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var HomeView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "homeView",

		//model: HomeModel,

        initialize: function() {
        	console.log("in home view initialize");
        },

        render: function() {

			this.$el.html (compiled_template());

			var windowWidth = $(window).width() - 30;

			var windowHeight = $(window).height();
			var graphHeight = windowHeight - 300;

            var data = {
                labels: ["January", "February", "March", "April", "May", "June", "July"],
                datasets: [{
                    label: "My First dataset",
                    fillColor: "rgba(220,220,220,0.2)",
                    strokeColor: "rgba(220,220,220,1)",
                    pointColor: "rgba(220,220,220,1)",
                    pointStrokeColor: "#fff",
                    pointHighlightFill: "#fff",
                    pointHighlightStroke: "rgba(220,220,220,1)",
                    data: [202, 201, 200, 199, 200, 198, 196],
                    responsive: true
                }]
            };

            // Get the context of the canvas element we want to select.
            var ctx = this.$el.find('#myChart').get(0).getContext("2d");
            ctx.canvas.width = windowWidth;
            ctx.canvas.height = graphHeight;

            var myChart = new Chart(ctx).Line(data);


            return this;
        }
    });

    return HomeView;
});
