define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        PAData = require("models/PAData"),
        MCM_Keyboard_Plugin = require("plugin/MCM_Keyboard_Plugin"),
        WeightModel = require("models/WeightModel"),
       WeightsCollection = require('collections/weightsCollection'),
        template = require("text!templates/PAEntryTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);
    
    var db;// = window.sqlitePlugin.openDatabase({name: "USDA_PA.sqlite3", createFromLocation: 1});

    var dateEntered;

    var wtClear = true;

	var PAArray = [];
	var favArray = [];
	var customArray = [];
	
	var hrString = 0;
	var minString = 0;
	
	var totalMin = 0;
	
	var PADatabaseArray = [];
	var sortedArray = [];
	
	var entriesArray = [];

	var textString = "";
	var selectedIndex;
	var selectedPA;
    
    var aerobicActivity = false;
    var strengthActivity = false;
    var flexibilityActivity = false;
    var favorite = false;
    
    var enteringSteps = false;


    var PAEntryView = Backbone.View.extend({
        id: "PAEntryView",

        templateName: "PAEntryTemplate.html",

           events: {

			'click li#selectableCells  a#itemSelect': 'getIndex',
			'click li#favoriteCells  a#itemSelect': 'getIndex',
			'click li#selectableCells a#favSelect':'favTappedInSearch',
			'click ul#favoritesList a#favoriteListSelect':'tappedFavList',
            "click #doneButton": "doneButtonTapped",
            "change #Aerobic": "typeAerobicTapped",
            "change #Strength": "typeStrengthTapped",
            "change #Flexibility": "typeFlexibilityTapped",
            "click #stepsButton": "stepsButtonTapped",
            "click #customActivityButton": "customButtonTapped",
            "click #searchEntryButton": "searchButtonTapped",
            "click #newActivityButton": "singleCustomTapped",
            'swipeleft ul#customList li#customCells': function(ev){this.getIndexAndRemove(ev, "removeCustom");},
            'swiperight ul#customList li#customCells': function(ev){this.getIndexAndRemove(ev, "removeCustom");},
            'click ul#customList li#customCells a#favoriteListSelect': 'customFavTapped',
            'click ul#customList li#customCells a#itemSelect': 'editCustom' 


           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);
			
			this.collection = new WeightsCollection();

		},

		render: function() {
			
			
			
			log.debug ("calling render in userInfo view with template name: " + this.templateName);
			
        	
        	this.$el.html(template);

            textString = "";
            
            console.log("current weight from collection: " + this.collection.getCurrentWeight().get("weight"));
            
            this.$('#doneButton').addClass("ui-state-disabled");
            
            if(UserData.get("isEditing") == true){
            	this.editEntry();
            }else{
            
            /*
 * 
 * 
 * PA Database
 * 
 * 
 */

            
           var PAData = require("models/PAData");
           
           favArray = PAData.get("PAFavorites");
           
           customArray = PAData.get("customPA");
           
           // populates favorites list
           if(favArray.length > 0){
           for (var i=(Number(favArray.length) - 1);i>=0;i--){

           	this.$("#favoritesList").append('<li id="favoriteCells" style="white-space:normal;"><a id="itemSelect" data-selectType="favorite" style="font-size:14px; white-space:normal;">' + favArray[i].Desc + '</a><a id="favoriteListSelect" data-favState="true" data-favIndex="'+i+'" class="ui-alt-icon"></a></li>');
           }
           }else{
           	this.$("#favoritesResults").hide();
           }
        

            	        	if(customArray.length > 0){
           for (var i=(Number(customArray.length) - 1);i>=0;i--){
           	
           	var favAdded = false;
                	for (var k = 0;k<favArray.length;k++){
                		if(favArray[k].Desc === customArray[i].Desc){
                			favAdded = true;
                		}
                	}
            			if(favAdded == false){
            				this.$("#customList").append('<li id="customCells" data-masterArrayIndex = "' + i + '" style="white-space:normal;"><a href="#addSingleCustom" id="itemSelect" data-masterArrayIndex = "' + i + '" data-selectType="custom" style="font-size:14px; white-space:normal;">' + customArray[i].Desc + '</a><a id="favoriteListSelect" data-favState="false" data-favIndex="'+i+'""></a></li>');
            			}else{        				
            				this.$("#customList").append('<li id="customCells" data-masterArrayIndex = "' + i + '" style="white-space:normal;"><a href="#addSingleCustom" id="itemSelect" data-masterArrayIndex = "' + i + '" data-selectType="custom" style="font-size:14px; white-space:normal;">' + customArray[i].Desc + '</a><a id="favoriteListSelect" data-favState="true" data-favIndex="'+i+'" class="ui-alt-icon"></a></li>');
            			}
            			
           }
           }else{
           	this.$("#customResults").hide();
           }
            	
            	
            	/*
            	 * 
            	 * autocomplete attempt start
            	 * 
            	 */
            	var paDB = window.sqlitePlugin.openDatabase({name: "USDA_PA.sqlite3", createFromLocation: 1});
            	
            	 this.$( "#searchList" ).on( "filterablebeforefilter", function ( e, data ) {
        var $ul = $( this ),
            $input = $( data.input ),
            value = $input.val(),
            html = "";
        $ul.html( "" );
        if ( value && value.length > 2 ) {
            $ul.html( "<li><div class='ui-loader'><span class='ui-icon ui-icon-loading'></span></div></li>" );
            $ul.listview( "refresh" );
            
            var j = 0;
            if(favArray.length > 0){
            	for(var i=0;i<favArray.length;i++){
            		
            		var currentFav = favArray[i].Desc;
            		
            		
            		if(currentFav.toUpperCase().indexOf(value.toUpperCase()) > -1){
            			
            			html = '<li id="selectableCells" style="white-space:normal;"><a id="itemSelect" data-selectType="search" style="font-size:14px; white-space:normal;">';
            			html = html + favArray[i].Desc;
            			html = html + '</a><a id="favSelect" data-favState="true" data-favIndex="';
            			html = html + j;
            			html = html + '" class="ui-alt-icon"></a></li>';
            			
                		$ul.append(html);
                		$ul.listview( "refresh" );
                		$ul.trigger( "updatelayout");
                		
                		PAArray[j] = {
                		Desc: favArray[i].Desc, 
                		METS: favArray[i].METS,
                		favorite: true
                		};
                		
                		j++;
            	}
            	}
            }
            
            
            if(customArray.length > 0){
            	for(var i=0;i<customArray.length;i++){
            		
            		var currentCust = customArray[i].Desc;
            		
            		
            		if(currentCust.toUpperCase().indexOf(value.toUpperCase()) > -1){
            			
            			var favAdded = false;
                	for (var k = 0;k<favArray.length;k++){
                		if(favArray[k].Desc === customArray[i].Desc){
                			favAdded = true;
                		}
                	}
            			if(favAdded == false){
            			html = '<li id="selectableCells" style="white-space:normal;"><a id="itemSelect" data-selectType="search" style="font-size:14px; white-space:normal;">';
            			html = html + customArray[i].Desc;
            			html = html + '</a><a id="favSelect" data-favState="false" data-favIndex="';
            			html = html + j;
            			html = html + '"></a></li>';
            			
                		$ul.append(html);
                		$ul.listview( "refresh" );
                		$ul.trigger( "updatelayout");
                		
                		PAArray[j] = {
                		Desc: customArray[i].Desc, 
                		METS: customArray[i].METS,
                		favorite: true
                		};
                		
                		j++;
                	}
            	}
            	}
            }
            
            var queryString = "SELECT Desc,METS FROM USDA_PA WHERE Desc LIKE '%" + value + "%'";
                 
        paDB.transaction(function(tx){
         
            	tx.executeSql(queryString,[],function(tx,res){
                
                for(var i=0; i < res.rows.length; i++){
                	
                	var favAlreadyAdded = false;
                	for (var k = 0;k<favArray.length;k++){
                		if(favArray[k].Desc === res.rows.item(i).Desc){
                			favAlreadyAdded = true;
                		}
                	}
                	
                	
                	
                	if(favAlreadyAdded == false){
                	PAArray[j] = {
                		Desc: res.rows.item(i).Desc, 
                		METS: res.rows.item(i).METS,
                		favorite:false
                		};
                		
                		
                		html = '<li id="selectableCells" style="white-space:normal"><a id="itemSelect" data-selectType="search" style="font-size:14px; white-space:normal;">' + PAArray[j].Desc + '</a><a id="favSelect" data-favState="false" data-favIndex="'+j+'"></a></li>';
                		
                		$ul.append(html);
                		$ul.listview( "refresh" );
                $ul.trigger( "updatelayout");
                j++;
                }else{
                	console.log(res.rows.item(i).Desc + " is a favorite");
                }
                }
                
               PAData.set("PADatabase",PAArray);
               PAData.save();
            
            }
            
        );
        
        
        
        });
        
           
        }
    });
            	/*
            	 * 
            	 * autocomplete attempt end
            	 * 
            	 * 
            	 */
            
           }
            


            return this;
		},
        getIndex: function(ev){
        	
        	var PAData = require("models/PAData");

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index() - 1;
        	        	
        	if(UserData.get("isEditing") == true){
            	selected_index = UserData.get("editIndex");
            	
            
			
			entriesArray = PAData.get("PAEntrys");
            	
            	selectedPA = {
                		Desc: entriesArray[selected_index].desc, 
                		METS: entriesArray[selected_index].mets
                		};
            	
            }else{
        	
        	if($(ev.currentTarget).attr("data-selectType") == "favorite"){
        		for(var i=0;i<favArray.length;i++){
        		if($(ev.currentTarget).html() == favArray[i].Desc){
        			selected_index = i;
        		}
        	}
        		
        		selectedPA = favArray[selected_index];
        	}else{
        		for(var i=0;i<PAArray.length;i++){
        		if($(ev.currentTarget).html() == PAArray[i].Desc){
        			selected_index = i;
        		}
        	}
        		
        		selectedPA = PAArray[selected_index];
        	}
        	
        	}
        	
        	PAData.set("selectedPA",selectedPA);
        	PAData.save();
        	
        	this.$('#activityEntryTypeBar').hide();

        	
        	this.$("#favoritesResults").hide();
        	
        	this.$("#searchResults").hide();
        	
        	this.$("#durationLabel").replaceWith('<p id="durationLabel">Enter the amount of time you spent on ' + selectedPA.Desc + ':</p>');
        	
        	
        	var isFav = false;
        	for(var i=0;i<favArray.length;i++){
        	if(selectedPA.Desc === favArray[i].Desc){
        		isFav = true;
        	}
        	}
        	
        	if(isFav == true){
        		this.$('#Favorite').attr("checked", true).checkboxradio('refresh');
        		
        	}else{
        		this.$('#Favorite').attr("checked", false).checkboxradio('refresh');
        	}
        	
        	favorite = isFav;
        	
        	entriesArray = PAData.get("PAEntrys");
        	
        	aerobicActivity = false;
        	strengthActivity = false;
        	flexibilityActivity = false;
        	
        	for (var i=0; i < entriesArray.length;i++){
        		if(selectedPA.Desc === entriesArray[i].desc){
        			aerobicActivity = entriesArray[i].aerobic;
        			strengthActivity = entriesArray[i].strength;
        			flexibilityActivity = entriesArray[i].flexibility;
        		}
        	}
        	
        	this.$('#Aerobic').attr("checked", aerobicActivity).checkboxradio('refresh');
        	this.$('#Strength').attr("checked", strengthActivity).checkboxradio('refresh');
        	this.$('#Flexibility').attr("checked", flexibilityActivity).checkboxradio('refresh');
        	
        	if(aerobicActivity == false && strengthActivity == false && flexibilityActivity == false){
					this.$('#doneButton').addClass("ui-state-disabled");
				}else{
					this.$('#doneButton').removeClass("ui-state-disabled");
				}
        	
        	this.$("#durationEntry").show("slow");
        	


        },
        enterFav: function(ev){
        	
        	
        	var PAData = require("models/PAData");

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index() - 1;
        	
        	
        	var paDB = window.sqlitePlugin.openDatabase({name: "USDA_PA.sqlite3", createFromLocation: 1});
        	
        	var queryString = "SELECT Desc,METS FROM USDA_PA WHERE Desc LIKE '%" + $(ev.currentTarget).html() + "%'";
        	
        	
        
        paDB.transaction(function(tx){
            	tx.executeSql(queryString,[],function(tx,res){
                
                for(var i=0; i < res.rows.length; i++){
                	
                	PAArray[i] = {
                		Desc: res.rows.item(i).Desc, 
                		METS: res.rows.item(i).METS,
                		favorite:false
                		};                		

                }
                PAData.set("PADatabase",PAArray);
               PAData.save();

               
               for(var i=0;i<PAArray.length;i++){
        		if($(ev.currentTarget).html() == PAArray[i].Desc){
        			selected_index = i;
        		}
        	}
        	
        	
        	PAData.set("selectedPA",PAArray[selected_index]);
        	PAData.save();
        	
        	this.$("#favoritesResults").hide();
        	
        	this.$("#searchResults").hide();
        	
        	this.$("#durationLabel").replaceWith('<p id="durationLabel">Enter the amount of time you spent on ' + PAArray[selected_index].Desc + ':</p>');
        	
        	
        	var isFav = false;
        	for(var i=0;i<favArray.length;i++){
        	if(PAArray[selected_index].Desc === favArray[i].Desc){
        		isFav = true;
        	}
        	}
        	
        	if(isFav == true){
        		this.$('#Favorite').attr("checked", true).checkboxradio('refresh');
        		
        	}else{
        		this.$('#Favorite').attr("checked", false).checkboxradio('refresh');
        	}
        	
        	favorite = isFav;
        	
        	this.$("#durationEntry").show("slow");
               
              });
            
          });
            
  


        },
		changeHours: function(){
			hrString = this.$("#hrSelect").val();
			minString = this.$("#minSelect").val();
			
			totalMin = (Number(hrString) * 60) + Number(minString);
			
			
		},
		changeMin: function(){
			hrString = this.$("#hrSelect").val();
			minString = this.$("#minSelect").val();
			
			totalMin = (Number(hrString) * 60) + Number(minString);
			
			
		},
		doneButtonTapped: function(){
			
			var entryDate = UserData.get("entryDate").toDateString();
			
			if(enteringSteps == true){
				
				// var steps = this.$("stepsDisplay").val(); 
				
				var steps = textString;
				
				console.log("Steps: " + steps);
				
				// var stepsArray = [];
				var stepsArray = PAData.get("stepEntrys");
				
				if(!stepsArray){
					stepsArray[0] = {steps: steps, date: entryDate};
				}else{
				stepsArray[stepsArray.length] = {steps: steps, date: entryDate};
				}
				
				PAData.set("stepEntrys",stepsArray);
			
				PAData.save();
				
				enteringSteps = false;
				
				console.log("Steps Array: " + JSON.stringify(PAData.get("stepEntrys")));
				
			}else{
			
			var hours = this.$("#hrSelect").val();
			
			var minutes = this.$("#minSelect").val();
			
			totalMin = (Number(hours) * 60) + Number(minutes);
			
			var PAEntryArray = [];
			
			PAEntryArray = PAData.get("PAEntrys");
			
			
			
			// var entryDate = new Date(); 
			
			// entryDate = entryDate.toDateString();
			
			if(UserData.get("isEditing") == true){
				
				// var caloriesPerMin = (Number(PAData.get('selectedPA').mets) * 3.5 * (Number(UserData.get("currentWeight")) * 0.4535924)) / 200;
				var caloriesPerMin = (Number(PAData.get('selectedPA').mets) * 3.5 * (Number(this.collection.getCurrentWeight().get("weight")) * 0.4535924)) / 200;
				
			
			var totalCalories = (Number(caloriesPerMin) * Number(totalMin));
				
				var editedEntry = {desc: PAData.get('selectedPA').desc, mets: PAData.get('selectedPA').mets, duration: totalMin, caloriesPerMin: caloriesPerMin, calories:totalCalories, dateOfActivity: entryDate, aerobic: aerobicActivity, strength: strengthActivity, flexibility: flexibilityActivity};
				
				PAEntryArray.splice(UserData.get("editIndex"),1,editedEntry);
			}else{
			
			var caloriesPerMin = (Number(PAData.get('selectedPA').METS) * 3.5 * (Number(this.collection.getCurrentWeight().get("weight")) * 0.4535924)) / 200;
			
			var totalCalories = (Number(caloriesPerMin) * Number(totalMin));
			
			if(!PAEntryArray){
				PAEntryArray[0]={desc: PAData.get('selectedPA').Desc, mets: PAData.get('selectedPA').METS, duration: totalMin, caloriesPerMin: caloriesPerMin, calories:totalCalories, dateOfActivity: entryDate, aerobic: aerobicActivity, strength: strengthActivity, flexibility: flexibilityActivity};
			}else{
				PAEntryArray[PAEntryArray.length]={desc: PAData.get('selectedPA').Desc, mets: PAData.get('selectedPA').METS, duration: totalMin, caloriesPerMin: caloriesPerMin, calories:totalCalories, dateOfActivity: entryDate, aerobic: aerobicActivity, strength: strengthActivity, flexibility: flexibilityActivity};	
			}
			}
			PAData.set("PAEntrys",PAEntryArray);
			PAData.set("selectedPA",undefined);
			
			PAData.save();
			
			UserData.set("isEditing", false);
			UserData.set("editIndex",undefined);
			UserData.set("editingObject",undefined);
			
			UserData.save();
			}
		},
		dataUpdate: function(){
			
			var textString;
			        
                    var that = this;
                    
			
			var searchString = "SELECT * FROM USDA_PA";
			

			db.transaction(function(tx){
            tx.executeSql("SELECT * FROM USDA_PA",[],function(tx,res){
                                
                var calories = 0;
       for(var i = 0; i < res.rows.length; i++){
       		caloriesPerMin = (Number(res.rows.item(i).METS) * 3.5 * (Number(this.collection.getCurrentWeight().get("weight")) * 0.4535924)) / 200;
       		caloriesPerMin = caloriesPerMin.toFixed(1);
       		arraystring = '<li id="selectableCells"><h2>' + res.row.item(i).desc + "</h2><p>" + caloriesPerMin + " Cal/min</p></li>";
       		console.log(arraystring);
       		that.$("#searchList").append(arraystring);
       }
                
       
            }
            
        );
        
        });
        
       
		},
		typeAerobicTapped:function(){

			if(aerobicActivity == false){
				aerobicActivity = true;
				this.$('#Aerobic').attr("checked", true).checkboxradio('refresh');
				this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				aerobicActivity = false;
				this.$('#Aerobic').attr("checked", false).checkboxradio('refresh');
				
			}
			
			
			if(aerobicActivity == false && strengthActivity == false && flexibilityActivity == false){
					this.$('#doneButton').addClass("ui-state-disabled");
				}
								

		},
		typeStrengthTapped:function(){

			if(strengthActivity == false){
				strengthActivity = true;
				this.$('#Strength').attr("checked", true).checkboxradio('refresh');
				this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				strengthActivity = false;
				this.$('#Strength').attr("checked", false).checkboxradio('refresh');
				
			}
			
			
			if(aerobicActivity == false && strengthActivity == false && flexibilityActivity == false){
					this.$('#doneButton').addClass("ui-state-disabled");
				}
				

		},
		typeFlexibilityTapped:function(){

			if(flexibilityActivity == false){
				flexibilityActivity = true;
				this.$('#Flexibility').attr("checked", true).checkboxradio('refresh');
				this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				flexibilityActivity = false;
				this.$('#Flexibility').attr("checked", false).checkboxradio('refresh');
				
			}
			
			
			if(aerobicActivity == false && strengthActivity == false && flexibilityActivity == false){
					this.$('#doneButton').addClass("ui-state-disabled");
				}
				

		},
		tappedFavList:function(ev){
			
			favorite = false;
			
			favArray.splice($(ev.currentTarget).attr("data-favIndex"),1);
			PAData.set("PAFavorites",favArray);
			PAData.save();
			
			this.render();
			
			$('body').enhanceWithin();
		},
		favTappedInSearch:function(ev){
			
			favorite = false;
			
			for(var i=0;i<favArray.length;i++){
				if(PAArray[$(ev.currentTarget).attr("data-favIndex")].Desc === favArray[i].Desc){
					favorite = true;
				}
			}
			
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(PAArray[$(ev.currentTarget).attr("data-favIndex")].Desc === favArray[i].Desc){
        		favorite = false;
        		favArray.splice(i,1);
        	}
        }
				
			}else{
					
				favArray[favArray.length]={Desc: PAArray[$(ev.currentTarget).attr("data-favIndex")].Desc,METS: PAArray[$(ev.currentTarget).attr("data-favIndex")].METS, favorite: true};
				favorite = true;

			}
			
			favorite = false;
			
			PAData.set("PAFavorites",favArray);
			PAData.save();
			
			this.render();
			
			$('body').enhanceWithin();
			
		},
		customFavTapped:function(ev){
			
			favorite = false;
			
			for(var i=0;i<favArray.length;i++){
				if(customArray[$(ev.currentTarget).attr("data-favIndex")].Desc === favArray[i].Desc){
					favorite = true;
				}
			}
			
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(customArray[$(ev.currentTarget).attr("data-favIndex")].Desc === favArray[i].Desc){
        		favorite = false;
        		favArray.splice(i,1);
        	}
        }
				
			}else{
					
				favArray[favArray.length]={Desc: customArray[$(ev.currentTarget).attr("data-favIndex")].Desc,METS: customArray[$(ev.currentTarget).attr("data-favIndex")].METS, favorite: true};
				favorite = true;

			}
			
			favorite = false;
			
			PAData.set("PAFavorites",favArray);
			PAData.save();
			
			this.render();
			
			$('body').enhanceWithin();
			
		},
		favoriteTapped:function(ev){
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(PAArray[selected_index].Desc === favArray[i].Desc){
        		favorite = false;
        		this.$('#Favorite').attr("checked", false).checkboxradio('refresh');
        		favArray.splice(i,1);
        	}
        }
				
			}else{
				favArray[favArray.length]={Desc: PAArray[selected_index].Desc,METS: PAArray[selected_index].METS, favorite: true};
				this.$('#Favorite').attr("checked", true).checkboxradio('refresh');
				favorite = true;
			}
				
				
				PAData.set("PAFavorites",favArray);
			PAData.save();
        	
			
			var selectedIndex = $(ev.currentTarget).index();

		},
		editEntry: function(){
			this.$("#favoritesResults").hide();
        	this.$("#activityEntryTypeBar").hide();
        	this.$("#cancelButton").hide();
        	
        	this.$("#searchResults").hide();
        	
        	selectedPA = UserData.get("editingObject");
        	
        	this.$("#durationLabel").replaceWith('<p id="durationLabel">Enter the amount of time you spent on ' + selectedPA.desc + ':</p>');
        	
        	var duration = selectedPA.duration;
        	
        	console.log("Duration: " + duration);
        	
        	console.log(JSON.stringify(selectedPA));
        	var hours = Math.trunc(Number(duration) / 60);
        	var min = Number(duration) - (Number(hours) * 60);
        	
        	this.$("#hrSelect").val(hours);
        	this.$("#minSelect").val(min);
        	
        	// entriesArray = PAData.get("PAEntrys");        	
        	
        	
        	
        	var PAData = require("models/PAData");        	
        	
        	
        	PAData.set("selectedPA",selectedPA);
        	PAData.save();
        	

        	
        	// this.$("#favoritesResults").hide();
        	
        	// this.$("#searchResults").hide();
        	
        	// this.$("#durationLabel").replaceWith('<p id="durationLabel">Enter the amount of time you spent on ' + selectedPA.desc + ':</p>');
        	
        	
        	
        	entriesArray = PAData.get("PAEntrys");
        	
        	
        	aerobicActivity = false;
        	strengthActivity = false;
        	flexibilityActivity = false;
        	

        			aerobicActivity = entriesArray[UserData.get("editIndex")].aerobic;
        			strengthActivity = entriesArray[UserData.get("editIndex")].strength;
        			flexibilityActivity = entriesArray[UserData.get("editIndex")].flexibility;
        			
        		/*for (var i=0; i < entriesArray.length;i++){
        		if(selectedPA.desc === entriesArray[i].desc){
        			aerobicActivity = entriesArray[i].aerobic;
        			strengthActivity = entriesArray[i].strength;
        			flexibilityActivity = entriesArray[i].flexibility;
        		}
        	}*/
        	
        	/*this.$('#Aerobic').attr("checked", aerobicActivity).checkboxradio('refresh');
        	this.$('#Strength').attr("checked", strengthActivity).checkboxradio('refresh');
        	this.$('#Flexibility').attr("checked", flexibilityActivity).checkboxradio('refresh');	
        		*/	
        			console.log("A: " + aerobicActivity + " | S: " + strengthActivity + " | F: " + flexibilityActivity);

        	if(aerobicActivity == true){
        		this.$('#Aerobic').replaceWith('<input type="checkbox" name="Aerobic" id="Aerobic" value="Aerobic" checked>');
        	
        	}
        	// this.$('#Aerobic').attr("checked", aerobicActivity).checkboxradio('refresh');
        	
        	if(strengthActivity == true){
        		this.$('#Strength').replaceWith('<input type="checkbox" name="Strength" id="Strength" value="Strength" checked>');
        	
        	}
        	
        	if(flexibilityActivity == true){
        		this.$('#Flexibility').replaceWith('<input type="checkbox" name="Flexibility" id="Flexibility" value="Flexibility" checked>');
        	
        	}
        	
        	
        	// this.$('#Strength').attr("checked", strengthActivity).checkboxradio('refresh');
        	
        	// this.$('#Flexibility').attr("checked", flexibilityActivity).checkboxradio('refresh');
        	
        	console.log("EA: " + entriesArray[UserData.get("editIndex")]);
        	
        	if(aerobicActivity == false && strengthActivity == false && flexibilityActivity == false){
					this.$('#doneButton').addClass("ui-state-disabled");
				}else{
					this.$('#doneButton').removeClass("ui-state-disabled");
				}
        	
        	this.$("#durationEntry").show("slow");
        	$('body').enhanceWithin();
			
		},
		stepsButtonTapped: function(){
			this.$('#activityEntryTypeBar').hide();
			
			enteringSteps = true;
        	
        	this.$('#doneButton').removeClass("ui-state-disabled");
        	
        	this.$("#favoritesResults").hide();
        	
        	this.$("#searchResults").hide();
        	
        	this.$("#stepsEntry").show();
        	
        	this.decimalKeypadRequired();
		},
        decimalKeypadRequired: function(){
        	
        	
        		//callback function for keyboard (this sends keyboard entries to the desired HTML tag to be changed)
            function onEdit(results){
                       console.log("keyboardResults: " + results);
                // displays text typed in
                this.$('#stepsDisplay').html(results);
                    
                // sets textString variable to set weight in UserData when done button tapped
                textString = 0;
                textString = results;
                
            }
                                            
            MCM_Keyboard_Plugin.getKeyboard(
                onEdit,     // callback function
                [0,0],      // native textfield location [x,y]          ** required **
                [0,0],      // native textfield size [width, height]    ** required **
                "0",         // current text in native textfield
                "",        // placeholder text in native textfield
                "Number"  // keyboard type in this case UIKeyboardTypeNumberPad
            );
            
                          
        },
        customButtonTapped:function(){
        	
        	this.$('#searchEntryButton').removeClass("ui-btn-active");
					this.$('#customActivityButton').addClass("ui-btn-active");
					
					this.$('#stepsButton').removeClass("ui-btn-active");
        	
        	this.$("#favoritesResults").hide();
        	
        	this.$("#searchResults").hide();
        	
        	this.$("#customEntry").show();
        	
			if(!customArray || customArray.length < 1){
					this.$("#customActivityResults").hide();
					this.$("#customLabel").hide();
				}
           
           this.$('body').enhanceWithin();
        	
        },
        searchButtonTapped: function(){
        	this.$("#favoritesResults").show();
        	
        	this.$("#searchResults").show();
        	
        	this.$("#customEntry").hide();
        	
        	if(!favArray || favArray.length < 1){
					this.$("#favoritesResults").hide();
				}
        },
        singleCustomTapped: function(){
        	UserData.set("singleCustomType","activity");
        	
        	UserData.save();
        },

		getIndexAndRemove: function (ev, arrayName) {

			selectedIndex = $(ev.currentTarget).index();
			console.log("index: " + selectedIndex);
			
			if(arrayName === "removeCustom"){
				// var entriesArray = PAData.get("customPA");
				var titleString = "Delete custom activity '" + customArray[$(ev.currentTarget).attr("data-masterArrayIndex")].Desc + "'?";
			}
			console.log("Array Index: " + $(ev.currentTarget).attr("data-masterArrayIndex"));
			
			var that=this;
			
			function onConfirm(buttonIndex) {
				
				
				if(buttonIndex == 1){
					
					
					if(favArray.length > 0){
  						
				var favIndex = -1;
				for (var i = 0; i<favArray.length;i++){
					
					if(customArray[$(ev.currentTarget).attr("data-masterArrayIndex")].Desc == favArray[i].Desc){
						favIndex = i;
					}
					
				}
				
				if(favIndex > -1){
					favArray.splice(favIndex,1);
				}
			

	  					PAData.set("PAFavorites",favArray);
					}
					
					customArray.splice($(ev.currentTarget).attr("data-masterArrayIndex"),1);
  					
  					PAData.set("customPA",customArray);
	  					
					PAData.save();
					
					
				that.render();	
				
				if(customArray.length < 1){
					that.$("#customActivityResults").hide();
				}
				
				if(favArray.length < 1){
					that.$("#favoritesResults").hide();
				}
				
					this.$('body').enhanceWithin();
					that.customButtonTapped();
					
				}
				
			};
			
			
			navigator.notification.confirm(
    			' ', // message
     			onConfirm,            // callback to invoke with index of button pressed
    			titleString,           // title
    			['Yes','No']     // buttonLabels
			);
			
			
		},
		editCustom:function(ev){
			
			selected_index = $(ev.currentTarget).attr('data-masterArrayIndex');
			
			console.log("go to edit page");
			console.log("Array index: " + selected_index);
			UserData.set("singleCustomType","activity");
        	UserData.set("customEditIndex",selected_index);
        	
        	UserData.save();
		}

		
    });

    return PAEntryView;
});
