define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        ProgressData = require("models/ProgressReviewModel"),
        template = require("text!templates/summaryProgressReview.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for a single model view, which is one guide
    summaryProgressReview = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "summaryProgressReviewView",

		model: ProgressData,

        initialize: function(args) {
 
            this.guideNum = args.guide;
                        
            if (this.guideNum === '7') {            	
            	this.model.set ("isGuide7", true);
            } else {
            	this.model.set ("isGuide7", false);
            }
            
            var self = this;
            
            Handlebars.registerHelper('getItems', function(type) {
            	            	
            	var arrayName = type + self.guideNum;
            	var dataArray = ProgressData.get(arrayName);
            	console.log ("array name: " + arrayName);
            	var dataString = "";
            	$.each (dataArray, function (index, value) {
            		dataString = dataString + '<li style="white-space:normal;">' + value + '</li>';
            	});
            	
            	if (dataString === "") {
            		dataString = "<li>None</li>";
            	}
            	
            	return new Handlebars.SafeString(dataString);
            	
            });
            
            Handlebars.registerHelper('getActivityGoalAnswer', function() {
          
           		//this catches the case where the user left the default value
           		var returnString = "No";
           		var value = ProgressData.get ("reachingActivityGoals" + self.guideNum); 
           		if (value === "Yes") {
           			returnString = "Yes";
           		}           
            	return returnString;       	
            });
            Handlebars.registerHelper('getDietGoalAnswer', function() {
            	var returnString = "No";
           		var value = ProgressData.get ("reachingDietGoals" + self.guideNum); 
           		if (value === "Yes") {
           			returnString = "Yes";
           		}            	        
            	return returnString;
            });        
        },

        render: function() {

            //this.model is created when we create the view in the router
           $(this.el).html(compiled_template(this.model.toJSON()));



            return this;
        }
    });

    return summaryProgressReview;
});
