define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/userInfo.html"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);
    
    var genderString = "";
        
        if (UserData.get("initialGender")){
        	genderString = UserData.get("initialGender");
        }else{
        	genderString = "Female";
        	UserData.set("initialGender",genderString);
        }
    
	var UserInfoView = Backbone.View.extend({
        id: "userInfoView",

        templateName: "userInfo.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
              // "change #joinedMOVE1": "saveJoinedMOVEData",
              // "change #joinedMOVE2": "saveJoinedMOVEData",
              // "change #MOVE_Hope1": "saveJoinedMOVEData",
              // "change #MOVE_Hope2": "saveJoinedMOVEData"  
              // "change #genderSwitch": "saveUserInfoData"
              "click #heightCell": "heightSelect",
              // "click #weightCell": "weightSelect",
              // "click #genderCell": "genderSelect",
              
              "change #genderSelect": "genderSelect",
              "click #ageCell": "ageSelect",
              "load #headerText": "selectHeader",
              'click #initialEntryDoneButton' : function() {console.log ("done button touched"); Backbone.history.loadUrl("#");},
              "click #weightCell": "weightSelect"
              
           },

		initialize: function(args) {
		    
		    Handlebars.registerHelper('getState', function() { 
		        var saveButtonState = ""
                if (!UserData.get("initialDataComplete")) {
                    saveButtonState = "ui-state-disabled";
                }
                return saveButtonState;
		    });
		    
			//console.log ("initializing userInfo view: " + this);
			
			// if (args.initialScreens === "yes") {
			     // this.initialScreens = "yes";
			     // this.model.set ("initialScreens", true); 
			// }
			//make sure we capture that this is for initial screens after back button is used in data gathering screens
			// if (this.initialScreens === "yes") {
			if (!UserData.get("initialDataComplete")) {
			      
			     UserData.set ("initialScreens", true);  
			    
			     if (UserData.get("initialGender") && UserData.get("initialHeight") && UserData.get("initialAge") && UserData.get("initialWeight")){
                    console.log ("data is complete, return to main screen without adding to back button stack");
                
                    this.intitialScreens = "no";
                    //UserData.set ("initialScreens", false);
                    
                    UserData.set ("initialDataComplete", true);
                    
                    console.log ("set up done/save button now");
                    
                 } else {
                     console.log ("Need to get some more info");
                   //  UserData.set ("initialDataComplete", false);
                 } 
                 UserData.save();
            }
		},
		
		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);
        	
            this.$el.html(compiled_template(this.model.toJSON()));
           
            //this.$('#initialEntryDoneButton').button("enable");
           
           if (genderString === "Female") {
				this.$('#genderSelect').replaceWith('<select name="genderSelect" id="genderSelect" title="Select Gender">\
				<option value="Female" selected="selected">Female</option>\
				<option value="Male">Male</option>\
			</select>');
			}else if (genderString === "Male") {
				this.$('#genderSelect').replaceWith('<select name="genderSelect" id="genderSelect" title="Select Gender">\
				<option value="Female">Female</option>\
				<option value="Male" selected="selected">Male</option>\
			</select>');
			}
			
            return this;
		},/*
		heightSelect: function(){
			var heightValue = prompt('Enter height in inches');
			
			// $(#heightValue).html(heightValue);
			
			// var textValue = this.$('#heightValue').val();
             UserData.set("initialHeight", heightValue);
             
             UserData.save();
		},*/
		/*weightSelect: function(){
			var weightValue = prompt('Enter weight in pounds (lbs)');
			
			UserData.set("initialWeight", weightValue);
             
             UserData.save();
		},*/
		genderSelect: function(){
			// var genderValue = prompt('Enter gender');
			
			genderString = this.$("#genderSelect").val();
			
			UserData.set("initialGender", genderString);
			 
            UserData.save();
		},
		/*ageSelect: function(){
			var ageValue = prompt('Enter your age to the nearest year');
			
			UserData.set("initialAge", ageValue);
             
             UserData.save();
		},*/
		selectHeader: function(){
			if(UserData.get("firstTimeEntriesComplete") !== true){
				$('#headerText').html("Please enter the following:");
			}else{
				$('#headerText').html("Welcome to MOVE! Coach, the following entries are required.");
			}
		},
		
		weightSelect: function(){
			 UserData.set('entryType',"weightEntry");
            UserData.save();
		}
		
	});
	return UserInfoView;
});