define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/weightLossGoal.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var WeightLossGoalsView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "weightLossGoalsView",


        initialize: function() {
            log.debug("here");
        },

        render: function() {
            // Calculate values.
            var weight = UserData.get("initialWeight");
            var percentToLose = UserData.get("initialPercentToLose");
            if (!weight && !percentToLose) {
                // Temp fix since the user is asked for this information when 1st starting the app.
                weight = 300;
                percentToLose = 5;
            }
            var goal = (weight * percentToLose) / 100;
            var targetWeight = weight - goal;

            // Merge data with template.
            $(this.el).html(compiled_template({
                initialWeight: weight,
                initialPercentToLose: percentToLose,
                goal: goal,
                targetWeight: targetWeight
            }));
            return this;
        }

    });

    return WeightLossGoalsView;
});
