define(function(require) {
    var log = require("loglevel");

    var pdfHelper = {

		handoutResourcesRootURL: "http://www.move.va.gov/download/NewHandouts/",
		defaultResourcesRootURL: "http://www.move.va.gov/download/",


        openHandoutsPDF: function (event) {
        	var completeURL = this.handoutResourcesRootURL + $(event.currentTarget).data ('url');
        	this.openPDF(completeURL);
        },

        openDownloadPDF: function (event) {
        	var completeURL = this.defaultResourcesRootURL + $(event.currentTarget).data ('url');
        	this.openPDF(completeURL);
        },
        
        openPDF: function (completeURL) {
        	console.log ("opening a PDF with url: " + completeURL);

        	var ref = window.open(completeURL, '_blank', 'location=no,toolbarposition=top,enableViewportScale=yes');

        	ref.addEventListener('loadstart', function(event) {
				//For non-iOS platforms, need to start showing activity indicator here
        	});

        	ref.addEventListener('loadstop', function(event) {
				//For non-iOS platforms, need to stop showing activity indicator here
        	});

        	ref.addEventListener('loaderror', function(event) {
				navigator.notification.confirm(
	    			'Please confirm your device is connected to the internet.', // message
	     			onConfirm,            // callback to invoke with index of button pressed
	    			'Error',           // title
	    			['OK']     // buttonLabels
				);

				var onConfirm = function() {
					console.log ("Error loading web resource.");
				};
        	});
		}
	};

	return pdfHelper;
});
