define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        GuidesCollection = require("collections/allGuides"),
        template = require("text!templates/guide.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for a single model view, which is one guide
    SingleGuideView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "singleGuideView",

        initialize: function(args) {
            
            this.model = GuidesCollection.get(args.id);
            console.log ("Guide model: " + JSON.stringify(this.model));
            
            console.log ("Guide model testing: " + this.model.get('chapters')[0].chapter);
            
			if (GuidesCollection.get(args.id).get("status") === "lock") {		
				this.showGuidesLockError();		
			} else {
				if (!this.model.get("startDate")) {
					this.model.set("startDate", new Date());   
				} 
			}
        },

        render: function() {
            //this.model is created when we create the view in the router
            $(this.el).html(compiled_template(this.model.toJSON()));

            return this;
        }, 
        showGuidesLockError: function () {
        	        	
        	var guideId = this.model.get ("id");
        	var tran = $.mobile.changePage.defaults.transition;
 			$.mobile.changePage.defaults.transition = "none";        	
        	        	
        	function onConfirm(buttonIndex) {
                
            	Backbone.history.history.go(-1);

				setTimeout(function(){
					$.mobile.changePage.defaults.transition = tran;	
		 		}, 200);
			}
        	
        	var currentTitle = GuidesCollection.get(guideId).get("title");
        	var titleString = "Guide " + guideId + " '" + currentTitle + "' is not active yet";
        	        
        	var messageString;
        	
        	if (guideId === '1') {        		
        		messageString = "You must complete 'Start Self Management Guides' first";
        	} else {
        		
        		var previousId = Number(guideId)-1;       		
        		var previousTitle = GuidesCollection.get(previousId).get("title");
        		var previousStatus = GuidesCollection.get(previousId).get("status");
        
        		if (previousStatus != "lock") {        			
        			var previousEndDate = new Date(GuidesCollection.get(previousId).get("endDate"));  
        			var previousGuideMonth =  Number(previousEndDate.getMonth()) + 1;
        			// previousGuideMonth = Number(previousGuideMonth) + 1;     			        			   
        			messageString = "You must complete Guide " + previousId + " '" + previousTitle + "' and start this guide on " + previousGuideMonth + "/" + previousEndDate.getDate() + "/" + previousEndDate.getFullYear(); 
        			
        		} else {
        			//give generic alert        			
        			messageString = "You must complete Guide " + previousId + " '" + previousTitle + "' first";        			
        		}        		
        	}
        	        	
        	if ( typeof navigator.notification == 'undefined') {
				if (confirm(titleString + " - " + messageString)) onConfirm(1);
			} else {
				navigator.notification.confirm(
					messageString, // message
					onConfirm,            // callback to invoke with index of button pressed
					titleString,           // title
					['OK']     // buttonLabels
				);
			}
        	
        }
    });

    return SingleGuideView;
});
