define(function(require) {
    var log = require("loglevel");

    var PortionsModel = Backbone.Model.extend({
    	id: "PortionsData", 
    	
    	defaults: {
			portionList: [],
			foodWithAnswerList: [],
			leftSlider: "not set",
			rightSlider: "not set",
			leftSliderCurrentIndex: "not set",
			rightSliderCurrentIndex: "not set"
    	},

		// [0] = image filename, [1] = display text, [2] = message text
		portionInfo:  [
					   ["baseball", "Baseball", "a baseball"],			// 0
					   ["CD-DVD", "CD / DVD", "a compact disc or DVD"],	// 1
					   ["mouse", "Computer Mouse", "a computer mouse"],	// 2
					   ["cards", "Deck of Cards", "a deck of cards"],	// 3
					   ["HockeyPuck", "Hockey Puck", "a hockey puck"],	// 4
					   ["Dice", "4 Dice", "two pair or four dice"],		// 5
					   ["TennisBall", "Tennis Ball", "a tennis ball"],	// 6
					   ["CheckBook", "Checkbook", "a checkbook"],		// 7
					   ["Egg", "Large Egg", "a large egg"],				// 8
					   ["GolfBall", "Golf Ball", "a golf ball"],		// 9
					   ["MatchBox", "Match Box", "a match box"],		// 10
					   ["Penny", "Penny", "a penny"],					// 11
					   ["Quarter", "Quarter", "a quarter"]				// 12
					  ],
					  
		// list of food with index of correct answer from the portionList
		foodListWithAnswersIndexed: [
					 ["Baked Potato", 2], //mouse
					 ["Bagel", 4], // hockey puck
					 ["Berries", 6], // Tennis Ball
					 ["Canned Fruit", 2], // mouse
					 ["Cheese", 5], // 4 dice
					 ["Chopped Fruit", 2], // mouse
					 ["Cooked Beans", 2], // mouse
					 ["Cooked Pasta", 2], // mouse
					 ["Cooked Veggies", 2], // mouse
					 ["Dry Cereal", 4], // hockey puck
					 ["Fish (2 ounces)", 3], // cards
					 ["French Fries", 3], // cards
					 ["Fruit", 6], // tennis ball
					 ["Low-fat Milk", 0], // baseball
					 ["Low-fat Yogurt", 0], // baseball
					 ["Meat (3 ounces)", 3], // card deck
					 ["Pancake", 1], // CD-DVD
					 ["Poultry (3 ounces)", 3], // cards
					 ["Raw Vegetables", 0], // baseball
					 ["Fish (3 ounces)", 7], // checkbook
					 ["Raisins", 8], // Egg
					 ["Nuts", 9],  // golf ball
					 ["meat (1 ounce)", 10],  // matchbox
					 ["poultry (1 ounce)", 10], // matchbox
					 ["Fat", 11],  // penny
					 ["Oil", 11],  // penny
					 ["Sugar", 11],  // penny
					 ["Salad Dressing", 12], // quarter
					 ["Mustard", 12], // quarter
					 ["Ketchup", 12], // quarter
					 ["Mayonnaise", 12] // quarter
				  ],
		fastFoodListInfo: [
				  	["French Fries", 0, 1, 2, 0, 1],
				  	["Tater Tots", 0, 1, 2, 0, 1],
				  	["Onion Rings", 0, 1, 2, 0, 1],
				  	["Hamburger", 3, 4, 5, 6, 7],
				  	["Pork Sandwich", 3, 4, 5, 6, 7],
				  	["Hot Dogs", 3, 4, 5, 6, 7],
				  	["Fried Chicken", 3, 4, 5, 6, 7],
				  	["Fried Fish", 8, 8, 8, 8, 8],
				  	["Clam Strips", 8, 8, 8, 8, 8],
				  	["Sundae", 9, 9, 9, 9, 9],
				  	["Banana Split", 9, 9, 9, 9, 9],
				  	["Cake", 9, 9, 9, 9, 9],
				  	["Brownie", 9, 9, 9, 9, 9],
				  	["Pie", 9, 9, 9, 9, 9],
				  	["Soda", 10, 11, 12, 13, 10],
				  	["Sweet Tea", 10, 11, 12, 13, 10],
				  	["Fruit Punch", 10, 11, 12, 13, 10],
				  	["Lemonade", 10, 11, 12, 13, 10]
				  ],
		healthyFoodListInfo: [
				  	["Baked Potato","Baked Potato","Baked Potato"], 		// 0
				  	["Salad","Salad","Salad"],				// 1
				  	["Fresh Fruit","Fresh Fruit","Fresh Fruit"],		// 2
				  	["Turkey","Turkey","Turkey"],				// 3
				  	["Roast Beef","Roast Beef","Roast Beef"],			// 4
				  	["Lean Ham","Lean Ham","Lean Ham"],			// 5
				  	["Grilled Chicken","Grilled Chicken","Grilled Chicken"],	// 6
				  	["Chicken Tacos","Chicken Tacos","Chicken Tacos"],		// 7
				  	["Broiled Shrimp","Broiled Shrimp","Broiled Shrimp"],		// 8
				  	["Frozen Yogurt","Frozen Yogurt","Frozen Yogurt"],		// 9
				  	["Water","Water","Water"],				// 10
				  	["Unsweet Tea","Unsweet Tea","Unsweet Tea"],		// 11
				  	["Low Fat Milk","Low Fat Milk","Low Fat Milk"],		// 12
				  	["100% Juice","100% Juice","100% Juice"]			// 13
				  ],

    	initialize: function(args) {
    		this.set("portionList", this.portionInfo);
    		this.set("foodWithAnswerList", this.foodListWithAnswersIndexed);
    		this.set("fastFoodList", this.fastFoodListInfo);
    		this.set("healthyFoodList", this.healthyFoodListInfo);
    	}
    	
	});
	
	return PortionsModel;
});

