define(function(require) {
    var log = require("loglevel");

    var TriggersAndFixesData = Backbone.Model.extend({
        localStorage: new Backbone.LocalStorage("triggersAndFixesData"),

        deferred: "",
        
		defaults:  {
			"unhealthyFoods": [],
			"triggers":[],
			//"fixes":[],
			//"currentTrigger":undefined, 
			"currentTriggerIndex":-1
			
		},

	    initialize: function() {
	    	
            // Fetch user data from local storage
            this.deferred = this.fetch({                          
                reset: true                           
            });
            
            this.on("reset", function(e) {
                this.deferred.resolve();
            });
        },

        parse: function(response) {
            //log.debug(JSON.stringify(response));
            return response[0];
        },

        clear: function() {
		}, 
		
		reset: function () {
			this.save();	
		},
		
		// addItemToList: function(listName, item) {
// 			
			// console.log ("Adding item: " + JSON.stringify(item) + " to list: " + listName);
// 			
			// var list = this.get (listName);
// 			
			// list.push(item);
			// this.save();
		// },
		
		// removeItemFromList: function (listName, index) {
// 					
			// console.log ("list name in delete in model: " + listName);
// 						
			// var returnVal = true;
// 			
			// var list = this.get (listName);
// 			
			// console.log ("index: " + index + " list length: " + list.length);
// 			
			// // if (index >= list.length) {
				// // returnVal = false;
			// // } else {
// 
				// list.splice(index, 1);			
				// this.save();
			// // }
// 			
			// console.log ("returning..." + returnVal);
// 			
			// return returnVal;
		// }, 
		
		addTrigger: function(trigger, index) {
		  		  
		  var newTriggerObj = {trigger: trigger, fixes:[]};  		  
		  var triggersArray = this.get("triggers");		    
		  triggersArray.push(newTriggerObj);		  
		  this.save()
		},
		
		deleteTrigger: function(index) {
		    		    
		    this.get("triggers").splice (index, 1);		                 
            this.save();
		},
		
		addFix: function(fix, index) {
		  
		  //get the correct Trigger to add/update the fix for
          var selectedIndex = this.get("triggers").length-1;
          if (this.get("currentTriggerIndex") >= 0) {
              //currentTriggerIndex is set by the view and allows the fix to be added to the correct Trigger
              selectedIndex = this.get("currentTriggerIndex");                
          } 
		  var trigger = this.get("triggers")[selectedIndex];		  

          //if fixIndex is valid, insert the fix at that index.  Otherwise just push it on the end.
          var fixIndex = trigger.fixes.length;
          if (index > -1) {
              fixIndex = index;
              this.deleteFix(fixIndex);  //remove the current entry and replace with edited entry         
          }
          trigger.fixes.splice(fixIndex, 0, fix);		  
		  this.save();  
		    
		},
		
		deleteFix: function(index) {
		    
		    var trigger = this.get("triggers")[this.get("currentTriggerIndex")];
		    
		    trigger.fixes.splice(index, 1);
		    this.save();
		    
		},
        
        addFood: function(food, index) {
          
           var foodsArray = this.get("unhealthyFoods");

          //if index is valid, insert the fix at that index.  Otherwise just push it on the end.
          var foodIndex = foodsArray.length;
          if (index >= 0) {
              foodIndex = index;
              this.deleteFood(foodIndex);  //remove the current entry and replace with edited entry         
          }
          foodsArray.splice(foodIndex, 0, food);         
          this.save();  
            
        },
        
        deleteFood: function(index) {                       
            
            this.get("unhealthyFoods").splice(index, 1);
            this.save();
            
        }		
	});
		
  	var triggersAndFixesData = new TriggersAndFixesData();
    return triggersAndFixesData;
});