define(function(require) {
    var UserData = require('models/UserData'),
    	// PAData = require('models/PAData'),
    	SurveyData = require('models/SurveyData'),
    	// PortionData = require("models/PortionData"),
        // NutritionData = require("models/NutritionData"),
        PageView = require('views/PageView'),
        HomeView = require('views/HomeView'),
        AddEntryView = require('views/addEntryView'),
        PAEntryView = require('views/PAEntryView'),
        WeightView = require('views/weightView'),
        AllGuidesView = require('views/allGuidesView'),
        GuidesCollection = require("collections/allGuides"),
        SingleGuideView = require('views/singleGuideView'),
        GuideChapterView = require('views/GuideChapterView'),
        ResourceListView = require('views/ResourceListView'),
        DietEntryView = require('views/DietEntryView'),
        SingleCustomView = require('views/SingleCustomView'),
        
        FoodPortionsView = require('views/FoodPortionsView'),
        FoodPortionsModel = require('models/FoodPortionsModel'),
		
        SJBView = require('views/SJBView'),
        SurveyView = require('views/SurveyView'),
        G1GetReadyView = require('views/G1GetReadyView'),
        G2GetReadyView = require('views/G2GetReadyView'),
        G3GetReadyView = require('views/G3GetReadyView'),
        G4GetReadyView = require('views/G4GetReadyView'),
        // G5GetReadyView = require('views/G5GetReadyView'),
        // GetReadyView = require('views/GetReadyView'),
        G2Ch1CalRangeView = require('views/G2Ch1_calRangeView'),
        EulaView = require('views/EulaView'),
        GoalsProgressView = require('views/GoalsProgressView'),
        GuideSummariesView = require('views/GuideSummariesView'),
        SingleGuideSummaryView = require('views/SingleGuideSummaryView'),
        AllGuideSummariesView = require('views/AllGuideSummariesView'),
        SingleGuideProgressReviewView = require('views/SingleGuideProgressReviewView'),
        WeightLossGoalsView = require('views/WeightLossGoalsView'),
        WeightLossGoalEntryView = require('views/WeightLossGoalEntryView'),
        WeightLossPercentEntryView = require('views/WeightLossPercentEntryView'),
        WeightLossTargetEntryView = require('views/WeightLossTargetEntryView'),
        WeightLossRateEntryView = require('views/WeightLossRateEntryView'),
        MCAEntryView = require('views/MCAEntryView'),
        CurrentWeightEntryView = require('views/CurrentWeightEntryView'),
        AgeEntryView = require('views/AgeEntryView'),
        HeightEntryView = require('views/HeightEntryView'),
        BaselineWeightEntryView = require('views/BaselineWeightEntryView'),
        SettingsView = require('views/allSettingsView'),
        G6C1ReductionOptionsView = require('views/G6C1ReductionOptionsView'),
        GenericPageDisplayView = require('views/GenericPageDisplayView'),
        UserInfoView = require('views/UserInfoView'),

		// diaries
        DiaryWeightView = require('views/DiaryWeightView'),



        EntryHomeView = require ('views/EntryHomeView');

	// global changePage function for all routers
	Backbone.Router.prototype.changePage = function(page) {
        $(page.el).attr('data-role', 'page');
		$(page.el).addClass ('ui-page-header-fixed');

        // Render the page. This should merge data with the page template
        //  and attach the results to the page element.
        page.render();

        // Append the page element to the body element
        $('body').append($(page.el));

        // var transition = "slide";

        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        } else {
        	//$.mobile.changePage.defaults.transition = "slide";

        }

        $(":mobile-pagecontainer").pagecontainer("change", $(page.el), {
            changeHash: false,
            // transition: transition,
        });

		$('body').enhanceWithin();

        $.mobile.changePage.defaults.reverse = false;
    
    //attempt to preserve last page visited to facilitate easy back button. Not sure how reliable this is yet.    
        if (this.historyArray.length > 1) {
            this.historyArray.shift(); 
//            console.log ("removing array element size is " + this.historyArray.length);
        }         
        this.historyArray.push(Backbone.history.fragment);
                   
  //      console.log("history changepage: " + this.historyArray + "   array size is: " + this.historyArray.length);


        //this stops the timer that updates the date and time in EntryHomeView
        if (page.id != "entryHomeContainerView") {
            clearInterval (this.timeDateUpdate);
        }
    };


    return Backbone.Router.extend({

        routes: {
            "": "home",

            "mainSettings": "loadSettings",

            "addEntry": "addEntry",
            "addPA": "addPA",
            "addDiet": "addDiet",
            "weight": "loadWeights",
            "survey" : "surveyPage",
            "g1GetReady": "guide1GetReadyPage",
            "g2GetReady": "guide2GetReadyPage",
            "g3GetReady": "guide3GetReadyPage",
            "g4GetReady": "guide4GetReadyPage",
            "g5GetReady": "guide5GetReadyPage",
            "addSingleCustom": "addSingleCustom",
            

            "guides": "loadGuidesList",
            "guide/:id": "loadGuide",
            //"guide/:id/chapter/:chapter": "loadChapter",
            "guide/:id/chapter/:chapter/page/:page": "loadChapter",

            "guide/:id/objective": "displayObjective",
            "guide/:id/homework": "displayHomework",
            "aboutGuides/:id": "displayAboutGuides",
            "guide/:id/getReady": "displayGetReady",
            "guide/:id/congrats": "displayCongrats",
            // "guide/:id": "guideGetReadyPage",
            "relatedHandouts/:id": "displayResourcesList",
            
            "transcript/*path": "displayTranscript",

            // "howToSolveProblems": "solveProblems",
            
            "goalsAndProgress": "goalsAndProgress",
            "guideSummaries" : "guideSummaries",
            "guideSummary/:id": "loadGuideSummary",
            "progressReview/:id": "loadGuideProgressReview",
            "allGuideSummaries" : "loadAllGuideSummaries",

            "eula": "displayEULA",
            
			
			"sjb": "sjbTest",

			"G2C2NutritionLabelDetail/:pageNum": "displayNutritionDetail",
			// "getReady/:guide": "displayGetReady",

            // You can refactor groups of routes into seperate routers since
            // this class is going to get very large. Keep the generic stuff
            // in the default router.
            // 
            // NOTE: Make sure the same
            // route is not in multiple routers.
            "heightEntry": "displayHeightEntry",
            "ageEntry": "displayAgeEntry",
            "baselineWeightEntry" : "displayBaselineWeightEntry",
            "targetWeightEntry": "displayTargetWeightEntryView",
            "weight-loss-goals": "displayWeightLossGoals",
            "weight-loss-goal-entry": "displayGoalEntryView",
            "weight-loss-percent-entry": "displayPercentEntryView",
            "target-weight-entry": "displayTargetWeightEntryView",
            "medicalCalorieAdjustmentEntry": "displayMCAEntryView",
            "weightLossRateEntry": "displayWeightLossRateEntry",
            "currentWeightEntry": "displayCurrentWeightEntryView",
            "G2Ch1CalRange": "displayG2Ch1CalRangeView",
            "G6C1ReductionOptions" : "displayG6C1ReductionOptionsView",
            "initialDefaultScreens" : "displayInitialDefaultScreens",

			// Diaries
			"diaryWeight" : "displayWeightDiary",

            "entryPrototype" : "displayEntryHome"
        },

        initialize: function() {
            // Handle back button throughout the application
            // $(document).on('click', '.back', function() {

            //     window.history.back();
            //     return false;
            // });
            this.firstPage = true;
            
            this.historyArray = [];
            

        },

        home: function() {

            var view = null;

           //TESTING
           if (UserData.isTesting()) {
                              
              // UserData.set ("isEulaComplete", false);
              UserData.set ("isEulaComplete", true);
              UserData.set ("initialHeight", 68);
              UserData.set ("heightFTComponent", "5");
              UserData.set ("heightINComponent", "8");
              UserData.set ("initialAge", 42);
              UserData.set ("initialWeight", 222);
              UserData.set ("initialGender", "male");
              UserData.set("initialDataComplete", true);
               
           }
           //TESTING COMPLETE


            // Has the user viewed the EULA?
			if (!UserData.get("isEulaComplete")) {
                // No. Display EULA
                mainRouter.navigate("#eula", {
                    trigger: true
                });

                //modify this to just look at a bool
           // } else if (!UserData.get("initialGender") || !UserData.get("initialHeight") || !UserData.get("initialAge") || !UserData.get("initialWeight")){
             } else if (!UserData.get("initialDataComplete")) {     
                this.changePage (new UserInfoView({model: UserData, initialScreens:"yes"}));                                          
                
            } else {
                
                UserData.set ("initialScreens", false);

                // Yes. Display main view
                view = new HomeView();
                this.changePage(view);
            }
        },

        loadGuidesList: function() {
            this.changePage(new AllGuidesView());
        },
        loadGuide: function(id) {
       		//when allGuides is initialized, the data model is updated with the latest status for each guide.
       		//This allows the guides to be updated with latest status whenever the user taps on a guide. 	
        	var allGuides = new AllGuidesView();
       
       		//router will try to load the guide page regardless of if the guide is locked.  The Guide view is responsible for determining if the Guide data should be shown or not.
       		this.changePage(new SingleGuideView({
                id: id
           	}));
        },
        loadChapter: function(id, chapter, page) {
        	console.log ("loading a chapter page in router");
            this.changePage(new GuideChapterView({
                guide: id,
                chapter: chapter,
                page: page
            }));
        },
        //everything that calls GenericPageDispaly may be in a single router
        displayAboutGuides: function(pageNumber) {
        	
        	console.log ("Display about guides");
        	this.changePage(new GenericPageDisplayView({
				type:"aboutGuides",
				pageNumber:pageNumber
	
            }));
        },
        displayHomework: function(id) {
            this.changePage(new PageView({
                // taking shortcut here. this name matches name in guides.json
                id: "homeworkLink",
                title: 'Homework',
                guide: id
            }));
        },
        displayObjective: function(id) {
            this.changePage(new PageView({
                // taking shortcut here. this name matches name in guides.json
                id: "objectivesLink",
                title: 'Objectives',
                guide: id
            }));
        },
        displayGetReady: function(id) {
            this.changePage(new PageView({
                // taking shortcut here. this name matches name in guides.json
                id: "getReadyLink",
                title: 'Get Ready',
                guide: id
            }));
        },
        displayCongrats: function(id) {
            this.changePage(new PageView({
                // taking shortcut here. this name matches name in guides.json
                id: "congratsLink",
                title: 'Congratulations',
                guide: id
            }));
        },
		displayTranscript: function (id) {
			this.changePage(new GenericPageDisplayView({
				type:"transcript",
				pageNumber:"0", 
				transcriptURL:id
            }));
		},

		displayResourcesList : function (id) {
			this.changePage(new ResourceListView({
                id: id
            }));	
		},
		
		displayNutritionDetail: function (pageNum) {
			this.changePage(new GenericPageDisplayView({
				type: "G2C2NutritionLabelDetail",
				pageNumber: pageNum
			}));
		},
		
		displayG6C1ReductionOptionsView: function(){
			this.changePage(new G6C1ReductionOptionsView());
		},
		
		/*displayGetReady: function (guide) {
			
			// console.log("displayGetReady guide = " + guide);
			
			this.changePage(new GenericPageDisplayView({guideNumber: guide}));
		},*/

        loadSettings: function() {
            this.changePage(new SettingsView());
        },

        addEntry: function() {
            this.changePage(new AddEntryView());
        },
        
        addPA: function() {
            this.changePage(new PAEntryView());
        },
        
        addDiet: function() {
            this.changePage(new DietEntryView());
        },

        loadWeights: function() {
            this.changePage(new WeightView());
        },
        
        surveyPage: function() {
            this.changePage(new SurveyView());
        },
        
        guide1GetReadyPage: function() {
            this.changePage(new G1GetReadyView({model: SurveyData}));
        },
        
        guide2GetReadyPage: function() {
            this.changePage(new G2GetReadyView({model: SurveyData}));
        },
        
        guide3GetReadyPage: function() {
            this.changePage(new G3GetReadyView({model: SurveyData}));
        },
        
        guide4GetReadyPage: function() {
            this.changePage(new G4GetReadyView({model: SurveyData}));
        },
        addSingleCustom: function() {
        	this.changePage(new SingleCustomView());
        },

        // solveProblems: function() {
            // console.log("tapped How To Solve Problems");
        // },

        goalsAndProgress: function() {
            console.log("Tapped Goals And Progress");
            this.changePage(new GoalsProgressView());
        },

        guideSummaries: function() {
            console.log("Tapped Guide Summaries");
            this.changePage(new GuideSummariesView());
        },
        
        loadGuideSummary: function(id) {
            this.changePage(new SingleGuideSummaryView({
                id: id
            }));
        },

        loadAllGuideSummaries: function() {
            this.changePage(new AllGuideSummariesView());
        },

        loadGuideProgressReview: function(id) {
            this.changePage(new SingleGuideProgressReviewView({
                guideId: id
            }));
        },

        displayEULA: function() {
            this.changePage(new EulaView());
        },
        
        displayInitialDefaultScreens: function() {
            this.changePage(new UserInfoView({model: UserData, initialScreens:"yes"}));
        },
        
        sjbTest: function() {
            console.log("SJB Test Function");
            this.changePage(new SJBView({model:new FoodPortionsModel()}));
        },

        // TODO: Refactor to seperate router.
        displayWeightLossGoals: function() {
            this.changePage(new WeightLossGoalsView({model: UserData}));
        },
        displayGoalEntryView: function() {
            this.changePage(new WeightLossGoalEntryView({model: UserData}));
        },
        displayPercentEntryView: function() {
            this.changePage(new WeightLossPercentEntryView({model: UserData}));
        },
        displayTargetWeightEntryView: function() {
            this.changePage(new WeightLossTargetEntryView({model: UserData}));
        },
        displayBaselineWeightEntry: function() {
            this.changePage(new BaselineWeightEntryView({model: UserData}));
        },
        displayAgeEntry: function() {
            this.changePage(new AgeEntryView({model: UserData}));
        },
        displayHeightEntry: function() {
            this.changePage(new HeightEntryView({model: UserData}));
        },
        displayWeightLossRateEntry: function() {
        	this.changePage(new WeightLossRateEntryView({model: UserData}));
        },
        displayMCAEntryView: function(){
        	this.changePage(new MCAEntryView({model: UserData}));
        },
        displayCurrentWeightEntryView: function(){
        	this.changePage(new CurrentWeightEntryView({model: UserData}));
        },
        displayG2Ch1CalRangeView : function(){
        	this.changePage(new G2Ch1CalRangeView({model: UserData}));
        },

		// Diaries

        displayWeightDiary : function(){
        	//this.changePage(new DiaryWeightView({model: UserData}));
        	
        	var entryHomeView = new EntryHomeView({weightLog:true});
                        
            this.timeDateUpdate = setInterval(entryHomeView.updateDate, 60000);
            this.changePage(entryHomeView);
        	
        },

        
        displayEntryHome: function() {
            console.log ("Display the entry home screen prototype - rename this to something more permenant sounding");
            var entryHomeView = new EntryHomeView({});
                        
            this.timeDateUpdate = setInterval(entryHomeView.updateDate, 60000);
            this.changePage(entryHomeView);
            
        }

    });
});