define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        NutritionData = require("models/NutritionData"),
        MCM_Keyboard_Plugin = require("plugin/MCM_Keyboard_Plugin"),
        template = require("text!templates/DietEntryTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var dateEntered;

	var PortionArray = [];
	var NutritionArray = [];
	var favArray = [];
	
	var selectedFood;
	var selectedPortion;
	
	var food_index;
	var portion_index;
	
	var hungerMood = false;
	
	var mindful = false;
	var	portionControlled = false;
	var	healthy = false;
	
	var textString = 1.0;

    var wtArray = UserData.get("currentWeight");


    var DietEntryView = Backbone.View.extend({
        id: "DietEntryView",

        templateName: "DietEntryTemplate.html",

           events: {

			'click li#selectableCells  a#itemSelect': 'getIndex',
			'click li#favoriteCells  a#itemSelect': 'getIndex',
			'click ul#portionsList li#selectPortionCell': 'portionTapped',
			'click li#selectableCells a#favSelect':'favTappedInSearch',
			'click ul#favoritesList a#favoriteListSelect':'tappedFavList',
            "click #doneButton": "doneButtonTapped",
            "click #addWater": "waterTapped",
            "click #customButton": "customButtonTapped",
            "click #entryButton": "searchButtonTapped",
            "change #Mindful": "mindfulTapped",
            "change #PortionControlled": "portionControlledTapped",
            "change #Healthy": "healthyTapped",
            "click #hungerButton": "mealHungerMoodTapped",
            "click #newFoodButton":"singleCustomTapped"
           

           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);

		},

		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);

        	
        	this.$el.html(template);

            textString = "";
            
            this.$("#mealTitle").html(UserData.get("selectedMeal"));
            
            if(UserData.get("selectedMeal") == "Snack"){
            	// this.$("#hungerButton").hide();
            	
            	this.$("#dietEntrySelectBar").replaceWith('<div data-role="navbar" id="dietEntrySelectBar"><ul><li><a class="ui-btn ui-btn-active " id="entryButton">Search</a></li><li><a class="ui-btn" id="customButton">Custom</a></li><li><a class="ui-btn" id="addWater">Water</a></li></ul></div>');
            	
            }
            
            
			this.$('#doneButton').addClass("ui-state-disabled");
			
			if(UserData.get("isEditing") == true){
            	this.editEntry();
            }else{
            	
			favArray = NutritionData.get("foodFavorites");
			
			// console.log("favarray: " + favArray);
           
           // populates favorites list
           if(favArray.length > 0){
           for (var i=0;i<favArray.length;i++){
           	
           	this.$("#favoritesList").append('<li id="favoriteCells" style="white-space:normal"><a id="itemSelect" data-selectType="favorite" style="font-size:14px; white-space:normal;">' + favArray[i].foodname + '</a><a id="favoriteListSelect" data-favState="true" data-favIndex="'+i+'" class="ui-alt-icon"></a></li>');
           	
           }
           }else{
           	this.$("#favoritesResults").hide();
           }
           
           
           
			
/*
 * 
 * 
 * Nutrition Database
 * 
 * 
 */

     
            	
            	/*
            	 * 
            	 * autocomplete attempt start
            	 * 
            	 */
            	var NutritionDB = window.sqlitePlugin.openDatabase({name: "USDA_Foods.sqlite3", createFromLocation: 1});
            	
            	 this.$( "#searchList" ).on( "filterablebeforefilter", function ( e, data ) {
        var $ul = $( this ),
            $input = $( data.input ),
            value = $input.val(),
            html = "";
        $ul.html( "" );
        if ( value && value.length > 2 ) {
            $ul.html( "<li><div class='ui-loader'><span class='ui-icon ui-icon-loading'></span></div></li>" );
            $ul.listview( "refresh" );
            
            
            var j = 0;
            if(favArray.length > 0){
            	for(var i=0;i<favArray.length;i++){

            		var currentFav = favArray[i].foodname;
            		
            		
            		if(currentFav.toUpperCase().indexOf(value.toUpperCase()) > -1){
            			
            			html = '<li id="selectableCells" style="white-space:normal"><a id="itemSelect" data-selectType="search" style="font-size:14px; white-space:normal;">';
            			html = html + favArray[i].foodname;
            			html = html + '</a><a id="favSelect" data-favState="true" data-favIndex="';
            			html = html + j;
            			html = html + '" class="ui-alt-icon"></a></li>';
            			
            		
            		
                		$ul.append(html);
                		$ul.listview( "refresh" );
                		$ul.trigger( "updatelayout");
                		
                		
                		NutritionArray[j] = {
                		foodcode: favArray[i].foodcode, 
                		foodname: favArray[i].foodname,
                		energy: favArray[i].energy
                		};
                		
                		j++;
            	}
            	}
            }
            
            
            var queryString = "SELECT foodcode,foodname,Energy FROM USDA_Foods WHERE foodname LIKE '%" + value + "%'";

        
        NutritionDB.transaction(function(tx){

            	tx.executeSql(queryString,[],function(tx,res){
                
                for(var i = 0; i < res.rows.length; i++){
                	
                	var favAlreadyAdded = false;
                	for (var k = 0;k<favArray.length;k++){
                		if(favArray[k].foodname === res.rows.item(i).foodname){
                			favAlreadyAdded = true;
                		}
                	}
                	
                	if(favAlreadyAdded == false){
                	
                	
                	NutritionArray[j] = {
                		foodcode: res.rows.item(i).foodcode, 
                		foodname: res.rows.item(i).foodname,
                		energy: res.rows.item(i).Energy
                		};
                		
                		
                		html = "<li id='selectableCells' style='white-space:normal'>" + NutritionArray[j].foodname + "</li>";
                		
                		html = '<li id="selectableCells" style="white-space:normal"><a id="itemSelect" data-selectType="search" style="font-size:14px; white-space:normal;">';
            			html = html + NutritionArray[j].foodname;
            			html = html + '</a><a id="favSelect" data-favState="true" data-favIndex="';
            			html = html + j;
            			html = html + '"></a></li>';
                		
                		$ul.append(html);
                		$ul.listview( "refresh" );
                $ul.trigger( "updatelayout");
                
                j++;
                }else{
                	console.log(res.rows.item(i).foodname + " is a favorite");
                }
                }
                

            
            }
            
        );
        
        
        
        });
           
           
        }
    });
            	/*
            	 * 
            	 * autocomplete attempt end
            	 * 
            	 * 
            	 */
            	
		}

            return this;
		},
        getIndex: function(ev){

        	// gets index of selected cell
        	food_index = $(ev.currentTarget).index() - 1;
        	
 
        	this.$("#favoritesResults").hide();
        	
        	this.$("#waterEntry").hide();
        	
        	this.$("#dietEntrySelectBar").hide();
        	
        	if($(ev.currentTarget).attr("data-selectType") == "favorite"){
        		for(var i=0;i<favArray.length;i++){
        		if($(ev.currentTarget).html() == favArray[i].foodname){
        			selected_index = i;
        		}
        	}
        		
        		selectedFood = favArray[selected_index];
        	}else{
        		for(var i=0;i<NutritionArray.length;i++){
        		if($(ev.currentTarget).html() == NutritionArray[i].foodname){
        			selected_index = i;
        		}
        	}
        		
        		selectedFood = NutritionArray[selected_index];
        	}
        	
        	
        	NutritionData.set("selectedFoodData",selectedFood);
        	NutritionData.save();
        	
        	
        	this.$("#searchList").hide();
        	this.$("#searchResults").hide();
        	
        	        	this.$("#portionEntry").show("slow");
        	var selectedFoodPortions = [];
        	var j = 0;
        	
        	var $ul = this.$('#portionsList'),
            html = "";
        	
        	
        	 /*
       * 
       * 
       * Portions Database
       * 
       * 
       */ 
       // Portions database populate
       
       var PortionData = require("models/PortionData");
       
        
        var PortionDB = window.sqlitePlugin.openDatabase({name: "USDA_Portions.sqlite3", createFromLocation: 1});
        // console.log("selected Food: " + JSON.stringify(selectedFood));
        
        // var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodname LIKE '%" + selectedFood.foodname + "%' AND foodcode LIKE '%" +  selectedFood.foodcode + "%'";
        
        // var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodname LIKE '%" + selectedFood.foodname + "%'";
        
        var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodcode LIKE '%" +  selectedFood.foodcode + "%'";

        
        PortionDB.transaction(function(tx){

            	tx.executeSql(portionQuery,[],function(tx,res){
                // console.log("res.rows.length: " + res.rows.length);
                var j = 0;
                for(var i = 0; i < res.rows.length; i++){
                	// console.log("selectedFoodCode: " + selectedFood.foodcode + " | portionDBCode: " + res.rows.item(i).foodcode);
                	// console.log("SFN: " + selectedFood.foodname + " \nDBN: " + res.rows.item(i).foodname);
                	
                	if(selectedFood.foodname == res.rows.item(i).foodname){
                	PortionArray[j] = {
                		foodcode: res.rows.item(i).foodcode,
                		foodname: res.rows.item(i).foodname,                 		
                		Portion_Factor: res.rows.item(i).Portion_Factor,
                		portiondesc: res.rows.item(i).portiondesc                		                		
						};

						var html = "<li id='selectPortionCell'>" + PortionArray[j].portiondesc + "</li>";
						
						j++;
						
						$ul.append(html);
                		$ul.listview( "refresh" );
                $ul.trigger( "updatelayout");
                }
						
                }
                
                
            }
            
        );
        
        
        
        });
        
        // console.log(JSON.stringify(selectedFood));
        	
        	this.$("#portionLabel").replaceWith('<p id="durationLabel">Select the serving size of ' + selectedFood.foodname + ' consumed:</p>');
        	

        },
		doneButtonTapped: function(){
			var PortionData = require('models/PortionData');
			if(hungerMood == true){
				
				
				
				var mealHungerMoodArray = [];
				mealHungerMoodArray = PortionData.get("hungerMood");
				
				// console.log("MHM Array: " + JSON.stringify(mealHungerMoodArray));
				
				var hungerEntry = {
					meal: UserData.get("selectedMeal"),
					date: UserData.get("entryDate").toDateString(),
					preMealHunger: this.$("#preMealHunger").val(),
					postMealHunger: this.$("#postMealHunger").val(),
					mood: this.$("#moodText").val(),
					mindful: mindful,
					portionControlled: portionControlled,
					healthy: healthy
				};
				
				// console.log("Hunger Entry: " + JSON.stringify(hungerEntry));
				
				var existingEntry = false;
				
				var currentDate = new Date(UserData.get("entryDate"));
				
				currentDate = currentDate.toDateString();
				
				// console.log(currentDate);
				
				var editIndex = 0;
				for (var i=0; i<mealHungerMoodArray.length;i++){
        		if(currentDate == mealHungerMoodArray[i].date){
        			if(UserData.get("selectedMeal") == mealHungerMoodArray[i].meal){
        				existingEntry = true;
        				editIndex = i;
        			}
        		}
        } 
        	// console.log("MHM2 Array: " + JSON.stringify(mealHungerMoodArray));
				if(existingEntry == true){
					mealHungerMoodArray.splice(editIndex,1,hungerEntry);
				}else{
					mealHungerMoodArray[mealHungerMoodArray.length] = hungerEntry;
				}
				
				// console.log("MHM3 Array: " + JSON.stringify(mealHungerMoodArray));
				
				PortionData.set("hungerMood",mealHungerMoodArray);
				
				PortionData.save();
				
				hungerMood = false;
			}else{
			var servings = Number(textString);
			
			servings = Number(this.$("#servingsDisplay").html());
			
			// console.log("servings: " + servings);
			
			if (servings < 0.01){
				servings = 1;
			}
			
			
			// var calories = Number(servings) * Number(PortionArray[portion_index].Portion_Factor) * Number(selectedFood.energy);
			var calories = Number(servings) * Number(selectedPortion.Portion_Factor) * Number(selectedFood.energy);
			
			var entry = {
				foodcode: selectedFood.foodcode,
				foodname: selectedFood.foodname,
				energy: selectedFood.energy,
				calories: calories,
				servings: servings,
				servingSize: selectedPortion.portiondesc,
				date: UserData.get("entryDate").toDateString(),
				meal: UserData.get("selectedMeal")
			};
			
			
			
			
			
			var DietEntryArray = [];
			
			DietEntryArray = PortionData.get("DietEntrys");
			
			if(UserData.get("isEditing") == true){
				
				DietEntryArray.splice(UserData.get("editIndex"),1,entry);
			}else{

				DietEntryArray[DietEntryArray.length]=entry;	
			}
			
			PortionData.set("DietEntrys",DietEntryArray);
			}
			PortionData.save();
			
			// for(var i=0; i < PortionData.get("DietEntrys").length; i++){
			// // console.log("DietEntrys[" + i + "]: " + JSON.stringify(PortionData.get("DietEntrys")[i]));
			// }
			
			
			
			UserData.set("isEditing", false);
			UserData.set("editIndex",undefined);
			UserData.set("editingObject",undefined);
			
			UserData.save();
		
		},
		waterTapped: function(){
			
			this.$("#favoritesResults").hide();
        	
        	this.$("#waterEntry").hide();
        	
        	this.$("#dietEntrySelectBar").hide();
        	
        	this.$("#searchList").hide();
        	this.$("#searchResults").hide();
			
			selectedFood = {"foodcode":"94000100","foodname":"Water, tap","energy":"0"};
			selectedPortion = {"foodcode":"94000100","foodname":"Water, tap","Portion_Factor":"0.2960","portiondesc":"fluid ounce(s)"};
			
			
			var enterServingsString = "Enter the number of " + selectedPortion.portiondesc + " sized servings of " + selectedPortion.foodname + " you consumed:"; 
			
			this.$('#servingsText').html(enterServingsString);
			
			this.$("#selectedServingPortionDesc").html(selectedPortion.portiondesc);
			
			this.$('#portionEntry').hide();
			this.$('#servingEntry').show();
			
			this.$('#doneButton').removeClass("ui-state-disabled");
			
			hungerMood = false;
			
			this.decimalKeypadRequired();
			
		},
		portionTapped: function(ev){
			
			hungerMood = false;
			// gets index of selected cell
        	portion_index = $(ev.currentTarget).index();
			
			selectedPortion = PortionArray[portion_index];
			
			// console.log("portion: " + JSON.stringify(selectedPortion));
			

			var enterServingsString = "Enter the number of " + PortionArray[portion_index].portiondesc + " sized servings of " + PortionArray[portion_index].foodname + " you consumed:"; 
			
			this.$('#servingsText').html(enterServingsString);
			
			this.$("#selectedServingPortionDesc").html(PortionArray[portion_index].portiondesc);
			
			this.$('#portionEntry').hide();
			this.$('#servingEntry').show();
			
			this.$('#doneButton').removeClass("ui-state-disabled");
			
			this.decimalKeypadRequired();
			
		
		},
        decimalKeypadRequired: function(){
        	
        	if(UserData.get("isEditing") == true){
        		//callback function for keyboard (this sends keyboard entries to the desired HTML tag to be changed)
        		// <span id="servingsDisplay">1.0</span>
        		this.$("#servingsDisplay").html(UserData.get("editingObject").servings);
        		
        	}
        	// else{
        		//callback function for keyboard (this sends keyboard entries to the desired HTML tag to be changed)
            function onEdit(results){
                       // console.log("keyboardResults: " + results);
                // displays text typed in
                this.$('#servingsDisplay').html(results);
                    
                // sets textString variable to set weight in UserData when done button tapped
                textString = 1.0;
                textString = results;
            }                                
            MCM_Keyboard_Plugin.getKeyboard(
                onEdit,     // callback function
                [0,0],      // native textfield location [x,y]          ** required **
                [0,0],      // native textfield size [width, height]    ** required **
                "1.0",         // current text in native textfield
                "",        // placeholder text in native textfield
                "Decimal"  // keyboard type in this case UIKeyboardTypeDecimalPad
            );
        	// }
            
                          
        },
		tappedFavList:function(ev){
			
			favorite = false;
			
			favArray.splice($(ev.currentTarget).attr("data-favIndex"),1);
			NutritionData.set("foodFavorites",favArray);
			NutritionData.save();
			
			this.render();
			
			$('body').enhanceWithin();
		},
		favTappedInSearch:function(ev){
			
			favorite = false;
			
			for(var i=0;i<favArray.length;i++){
				if(NutritionArray[$(ev.currentTarget).attr("data-favIndex")].foodname === favArray[i].foodname){
					favorite = true;
				}
			}
			
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(NutritionArray[$(ev.currentTarget).attr("data-favIndex")].foodname === favArray[i].foodname){
        		favorite = false;
        		favArray.splice(i,1);
        	}
        }
				
			}else{
				
				favArray[favArray.length]={
					foodcode: NutritionArray[$(ev.currentTarget).attr("data-favIndex")].foodcode, 
                	foodname: NutritionArray[$(ev.currentTarget).attr("data-favIndex")].foodname,
                	energy: NutritionArray[$(ev.currentTarget).attr("data-favIndex")].energy
				};
				
				favorite = true;
				
			}
			
			favorite = false;
			
			NutritionData.set("foodFavorites",favArray);
			NutritionData.save();
			
			this.render();
			
			$('body').enhanceWithin();
			
		},
		editEntry:function(){
			// gets index of selected cell
        	/*food_index = $(ev.currentTarget).index() - 1;
        	
 
        	
        	
        	if($(ev.currentTarget).attr("data-selectType") == "favorite"){
        		for(var i=0;i<favArray.length;i++){
        		if($(ev.currentTarget).html() == favArray[i].foodname){
        			selected_index = i;
        		}
        	}
        		
        		selectedFood = favArray[selected_index];
        	}else{
        		for(var i=0;i<NutritionArray.length;i++){
        		if($(ev.currentTarget).html() == NutritionArray[i].foodname){
        			selected_index = i;
        		}
        	}
        		
        		selectedFood = NutritionArray[selected_index];
        	}
        	
        	*/
        	
        	this.$("#waterEntry").hide();
        	
        	this.$("#dietEntrySelectBar").hide();
        	
        	this.$("#favoritesResults").hide();
        	
        	selected_index = UserData.get("editIndex");
        	
        	selectedFood = UserData.get("editingObject");
        	
        	NutritionData.set("selectedFoodData",selectedFood);
        	NutritionData.save();
        	
        	
        	this.$("#searchList").hide();
        	this.$("#searchResults").hide();
        	
        	        	this.$("#portionEntry").show("slow");
        	var selectedFoodPortions = [];
        	var j = 0;
        	
        	var $ul = this.$('#portionsList'),
            html = "";
        	
        	// console.log("foodcode: " + selectedFood.foodcode);
        	 /*
       * 
       * 
       * Portions Database
       * 
       * 
       */ 
       // Portions database populate
       
       var PortionData = require("models/PortionData");
       
        
        var PortionDB = window.sqlitePlugin.openDatabase({name: "USDA_Portions.sqlite3", createFromLocation: 1});
        // console.log("selected Food: " + JSON.stringify(selectedFood));
        
        // var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodname LIKE '%" + selectedFood.foodname + "%' AND foodcode LIKE '%" +  selectedFood.foodcode + "%'";
        
        // var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodname LIKE '%" + selectedFood.foodname + "%'";
        
        var portionQuery = "SELECT foodcode,foodname,Portion_Factor,portiondesc FROM USDA_Portions WHERE foodcode LIKE '%" +  selectedFood.foodcode + "%'";

        
        PortionDB.transaction(function(tx){

            	tx.executeSql(portionQuery,[],function(tx,res){
                // console.log("res.rows.length: " + res.rows.length);
                var j = 0;
                for(var i = 0; i < res.rows.length; i++){
                	// console.log("selectedFoodCode: " + selectedFood.foodcode + " | portionDBCode: " + res.rows.item(i).foodcode);
                	// console.log("SFN: " + selectedFood.foodname + " \nDBN: " + res.rows.item(i).foodname);
                	
                	if(selectedFood.foodname == res.rows.item(i).foodname){
                	PortionArray[j] = {
                		foodcode: res.rows.item(i).foodcode,
                		foodname: res.rows.item(i).foodname,                 		
                		Portion_Factor: res.rows.item(i).Portion_Factor,
                		portiondesc: res.rows.item(i).portiondesc                		                		
						};

						var html = "<li id='selectPortionCell'>" + PortionArray[j].portiondesc + "</li>";
						
						j++;
						
						$ul.append(html);
                		$ul.listview( "refresh" );
                $ul.trigger( "updatelayout");
                }
						
                }
                
                
            }
            
        );
        
        
        
        });
        
        	
        	this.$("#portionLabel").replaceWith('<p id="durationLabel">Select the serving size of ' + selectedFood.foodname + ' consumed:</p>');
			
		},
        customButtonTapped:function(){
        	hungerMood = false;
        	this.$("#favoritesResults").hide();
        	
        	this.$('#doneButton').addClass("ui-state-disabled");
        	
        	this.$("#searchResults").hide();
        	this.hungerMoodSave();
        	this.$("#mealHungerMoodEntry").hide();
        	this.$("#customEntry").show();
        },
        searchButtonTapped: function(){
        	this.$("#favoritesResults").show();
        	
        	this.$('#doneButton').addClass("ui-state-disabled");
        	
        	this.$("#searchResults").show();
        	
        	this.$("#customEntry").hide();
        	this.hungerMoodSave();
        	this.$("#mealHungerMoodEntry").hide();
        },
        mealHungerMoodTapped:function(){
        	this.$("#favoritesResults").hide();
        	
        	this.$("#searchResults").hide();
        	this.$("#mealHungerMoodEntry").show();
        	this.$("#customEntry").hide();
        	
        	var PortionData = require("models/PortionData");
        	
        	var hungerMoodArray = PortionData.get("hungerMood");
        	 
        	
        	var currentDate = new Date(UserData.get("entryDate"));
        	currentDate = currentDate.toDateString();
        	
        	hungerMood = true;
        	
        	this.$('#doneButton').removeClass("ui-state-disabled");
        	// console.log("746 enable done " + hungerMoodArray.length);
        	
        	for (var i=0; i<hungerMoodArray.length;i++){
        		// console.log("748");
        		// console.log(hungerMoodArray[i].date + " | current date: " + currentDate);
        		if(currentDate == hungerMoodArray[i].date){
        			// console.log("750");
        			if(UserData.get("selectedMeal") == hungerMoodArray[i].meal){
        				// console.log("752");
        				
        			this.$("#preMealHunger").val(hungerMoodArray[i].preMealHunger).slider('refresh');			
					this.$("#postMealHunger").val(hungerMoodArray[i].postMealHunger).slider('refresh');
					this.$("#moodText").val(hungerMoodArray[i].mood);
					mindful = hungerMoodArray[i].mindful;
					portionControlled = hungerMoodArray[i].portionControlled;
					healthy = hungerMoodArray[i].healthy;
										
					if(mindful == true){
        		this.$('#Mindful').replaceWith('<input type="checkbox" name="Mindful" id="Mindful" value="Mindful" checked>');
        	
        	}
        	
        	if(portionControlled == true){
        		this.$('#PortionControlled').replaceWith('<input type="checkbox" name="PortionControlled" id="PortionControlled" value="PortionControlled" checked>');
        	
        	}
        	
        	if(healthy == true){
        		this.$('#Healthy').replaceWith('<input type="checkbox" name="Healthy" id="Healthy" value="Healthy" checked>');
        	
        	}
        				$('body').enhanceWithin();
        			// console.log("774 body enhance");	
        			}
        			
        		}
        	}
        	// console.log("779 mealHungerMoodTapped end");
        },
		mindfulTapped:function(){

			if(mindful == false){
				mindful = true;
				this.$('#Mindful').attr("checked", true).checkboxradio('refresh');
				// this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				mindful = false;
				this.$('#Mindful').attr("checked", false).checkboxradio('refresh');
				
			}
			
		},
		portionControlledTapped:function(){

			if(portionControlled == false){
				portionControlled = true;
				this.$('#PortionControlled').attr("checked", true).checkboxradio('refresh');
				// this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				portionControlled = false;
				
				this.$('#PortionControlled').attr("checked", false).checkboxradio('refresh');
				
			}
			
				

		},
		healthyTapped:function(){

			if(healthy == false){
				healthy = true;
				this.$('#Healthy').attr("checked", true).checkboxradio('refresh');
				// this.$('#doneButton').removeClass("ui-state-disabled");
			}else{
				healthy = false;
				this.$('#Healthy').attr("checked", false).checkboxradio('refresh');
				
			}
				

		},
		hungerMoodSave: function(){
			
			if(hungerMood == true){
			
				var PortionData = require('models/PortionData');
			
				var mealHungerMoodArray = PortionData.get("hungerMood");
			
				var hungerEntry = {
					meal: UserData.get("selectedMeal"),
					date: UserData.get("entryDate").toDateString(),
					preMealHunger: this.$("#preMealHunger").val(),
					postMealHunger: this.$("#postMealHunger").val(),
					mood: this.$("#moodText").val(),
					mindful: mindful,
					portionControlled: portionControlled,
					healthy: healthy
				};
				
				var existingEntry = false;
				
				var currentDate = UserData.get("entryDate").toDateString();
				var editIndex = 0;
				for (var i=0; i<mealHungerMoodArray.length;i++){
        		if(currentDate == mealHungerMoodArray[i].date){
        			if(UserData.get("selectedMeal") == mealHungerMoodArray[i].meal){
        				existingEntry = true;
        				editIndex = i;
        			}
        		}
        	}
        	
				if(existingEntry == true){
					mealHungerMoodArray.splice(editIndex,1,hungerEntry);
				}else{
					mealHungerMoodArray[mealHungerMoodArray.length] = hungerEntry;
				}
				
				
				PortionData.set("hungerMood",mealHungerMoodArray);
				
				hungerMood = false;
				PortionData.save();
			}
			
		},
        singleCustomTapped: function(){
        	UserData.set("singleCustomType","food");
        	
        	UserData.save();
        }

        
    });

    return DietEntryView;
});
