define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G2GetReady.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for Guide 1 Quesionnaire
    var G2GetReadyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g2GetReadyView",


        events: {
            'click #surveyComplete': 'storeSurveyData',
            'change #g2grpao-01': 'OtherClicked',
            'change #g2grpao-02': 'OtherClicked',
            'change #g2grpao-03': 'OtherClicked',
            'change #g2grpao-04': 'OtherClicked',
            'change #g2grpao-05': 'OtherClicked',
            'change #g2grpao-06': 'OtherClicked',
            'change #g2grpao-07': 'OtherClicked',
            'change #g2grpao-08': 'OtherClicked',
            'change #g2grpao-09': 'OtherClicked',
            'change #g2grpao-10': 'OtherClicked',
            'change #g2grpao-11': 'OtherClicked',
            'change #g2grpao-12': 'OtherClicked',
            'change #g2grpao-13': 'OtherClicked',
            'change #g2grpao-14': 'OtherClicked',
            'change #g2grpao-15': 'OtherClicked',
            'change #g2grpao-16': 'OtherClicked',
            'change #g2grpao-17': 'OtherClicked',
            'change #g2grpao-18': 'OtherClicked',
            'change #g2grpao-19': 'OtherClicked',
            'change #g2grpao-20': 'OtherClicked',
            'change #g2grpao-21': 'NoneClicked'
        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            return this;
        },

        NoneClicked: function(){

	this.$('#g2grpao-01').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-02').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-03').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-04').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-05').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-06').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-07').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-08').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-09').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-10').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-11').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-12').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-13').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-14').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-15').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-16').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-17').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-18').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-19').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-20').attr("checked", false).checkboxradio('refresh');
	this.$('#g2grpao-21').attr("checked", true).checkboxradio('refresh');

        },
        OtherClicked: function(){

	this.$('#g2grpao-21').attr("checked", false).checkboxradio('refresh');

        },

        storeSurveyData: function() {

			// record the selected reasons for being overweight
			var reasonField = $("#paObsticalListFieldSet input:checked");
            var selectedReasons = [];
            for (i=0; i < reasonField.length; i++)
            {
                selectedReasons[i] = reasonField[i].value;
            }
            SurveyData.set("paObsticals", selectedReasons);

            // there has to be a better way to do this
			// recording what was selected into the main issuesList
			// so it can be displayed as checked
			var reasonsKey;	// more performant?
			var reasons = SurveyData.get("paObsticalList");
			for (i=0; i < reasons.length; i++)
			{
				reasons[i].checked = false;
				reasonsKey = reasons[i].name;
	            for (j=0; j < selectedReasons.length; j++)
	            {
	            	if (selectedReasons[j] == reasonsKey)
					{
						reasons[i].checked = true;
						break;
					}
	       		}
            }


            SurveyData.save();
			Guides.get(2).save("getReadyComplete", "check");

			Backbone.history.history.back();
        }
    });

    return G2GetReadyView;
});
