define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        // G6C1ReductionOptionsView = require("views/G6C1ReductionOptionsView"),
        template = require("text!templates/G6C1FattyFoods.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var selected_index;

    // The view for Guide 1 Quesionnaire
    var G6C1FattyFoodsView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g6C1FattyFoodView",


        events: {
            'click #fattyFoodPopUp': 'generateReport',
            'click #frequencyButton': 'freqBtn',
            'click #amountButton': 'amountBtn',
            'click #substituteButton': 'subsBtn',
            'change #fattyFoodButton': 'getFoodName2',
            'swipeleft ul#fattyFoodsList li#deletableCells': 'getIndex',
            'swiperight ul#fattyFoodsList li#deletableCells': 'getIndex'


        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));

            var ffEntry = [];

             if(UserData.get("G6C1FattyFoodEntrys")){
             	var pulledFattyFood = UserData.get("G6C1FattyFoodEntrys");

             	for(var i=0; i < pulledFattyFood.length; i++){
             		console.log(pulledFattyFood[i]);
             		ffEntry[i] = pulledFattyFood[i];
             	}

             	for(var i=0; i < ffEntry.length; i++){
             		
             		this.$("#fattyFoodsList").append('<li id="deletableCells"><h2 id="textString">' + ffEntry[i].ffName + '</h2><p>' + ffEntry[i].subtitle + '</p></li>');
             		
             	}             	

             }




            return this;
        },
        getIndex: function(ev){

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index();

        	var ffEntry = [];

        	if(UserData.get("G6C1FattyFoodEntrys").length > 0){
        		var pulledFattyFood = UserData.get("G6C1FattyFoodEntrys");

             	for(var i=0; i < pulledFattyFood.length; i++){
             		console.log(pulledFattyFood[i]);
             		ffEntry[i] = pulledFattyFood[i];
             	}



             }

        	var titleString = 'Are you sure you want to delete ' + ffEntry[selected_index - 2].ffName + '?';

             	function onConfirm(buttonIndex) {
  					  if(buttonIndex === 1){

             	ffEntry.splice(selected_index - 2,1);

             	UserData.set("G6C1FattyFoodEntrys",ffEntry);
             	UserData.save();


             	$(ev.currentTarget).remove();

					}
					}


				navigator.notification.confirm(
    				' ', // message
     				onConfirm,            // callback to invoke with index of button pressed
    				titleString,           // title
    				['Yes','No']     // buttonLabels
					);


        },
        freqBtn: function(){
        	UserData.set("G6C1CurrentReductionType","Frequency");
        	UserData.save();
        },
        amountBtn: function(){
        	UserData.set("G6C1CurrentReductionType","Amount");
        	UserData.save();
        },
        subsBtn: function(){
        	UserData.set("G6C1CurrentReductionType","Substitution");
        	UserData.save();
        },
        getFoodName: function(){

        	function onPrompt(enteredValue){
        		if(enteredValue.buttonIndex === 2){
        			UserData.set("G6C1CurrentFood",enteredValue.input1);
        			UserData.save();

        			this.$("#fattyFoodsList").hide();
        			this.$("#firstText").hide();
        			this.$("#secondText").hide();
        			this.$("#fattyFoodExamples").hide();

        			this.$("#reductionText").replaceWith('<p id="reductionText">In order to reduce the amount of fat in my diet from ' + enteredValue.input1 + ', I will:</p>');
        			this.$("#reductionButtons").show("slow");

        		}
        	}

        	navigator.notification.prompt(
        		' ',  // message
    			onPrompt,                  // callback to invoke
    			'Enter a Fatty Food',            // title
    			['Cancel','OK'],             // buttonLabels
    			' '                 // defaultText
        	);

        },
        getFoodName2: function(){


			setTimeout(function(){

				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#fattyFoodButton";
       				var listID = "#fattyFoodsList";

					var value = this.$(textFieldID).val();

					if (value != "") {


						UserData.set("G6C1CurrentFood",value);
        			UserData.save();

        			this.$("#initialScreen").hide();

        			this.$("#reductionText").replaceWith('<p id="reductionText">In order to reduce the amount of fat in my diet from ' + value + ', I will:</p>');
        			this.$("#reductionButtons").show("slow");
					}
					
				}
				

				}, 100);

        },

        generateReport: function() {

            var message = "Alfredo or cream sauce pasta\nBacon, Sausage, franks, ribs\nBeans (refried or w/ added fat)\nButter, Gravy or creamed foods\nCakes, pies, brownies & cookies\nRegular Cheese\nFried chicken, fish. pork\nFried potatos or fried rice\nIce cream\nPizza\nMayonnaise-based salads\nWhole milk (4% fat)";
				navigator.notification.alert(
                message,    // message
                null,       // callback
                "Some Fatty Foods:", // title
                'OK'        // buttonName
            );


        }
    });

    return G6C1FattyFoodsView;
});
