define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        // PortionData = require("models/PortionData"),
        PAData = require("models/PAData"),
        template = require("text!templates/PAListTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var dateEntered;

	// var PortionArray = [];
	// var NutritionArray = [];
	
	var entriesArray = [];
	var favArray = [];
	
	var favorite = false;
	
	var selectedIndex;

    // var wtArray = UserData.get("weights");


    var PAListView = Backbone.View.extend({
        id: "PAListView",

        templateName: "PAListTemplate.html",

           events: {

            'click li#selectableCells a#favSelect':'favTappedInList',
            'click li#selectableCells a#itemSelect':'itemTappedInList'

           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);

		},

		render: function() {
			log.debug ("calling render in foodList view with template name: " + this.templateName);
        	
        	this.$el.html(template);            
            
            entriesArray = PAData.get("PAEntrys");
            
            favArray = PAData.get("PAFavorites");
            
            var currentDate = UserData.get("entryDate").toDateString();
            
            var paCalorieTotal = 0;
            
            var html="";
            
            
           for (var i=0;i<entriesArray.length; i++){
            	
            	var entryDate = entriesArray[i].dateOfActivity;
            	
            	if(currentDate == entriesArray[i].dateOfActivity){
            		
            		var isFav = false;
            		
            		for(var j=0;j < favArray.length; j++){
            			if(entriesArray[i].desc == favArray[j].Desc){
            				isFav = true;
            			}
            			
            		}
            		
            		if(isFav == true){
            			html = '<li id="selectableCells" style="white-space:normal" data-masterArrayIndex="'+i+'"><a id="itemSelect" href="#addPA" data-masterArrayIndex="'+i+'" data-selectType="search"><p style="font-size:14px; white-space:normal;"><b>' + entriesArray[i].desc + '</b></p><p>' + entriesArray[i].duration + ' Minutes<br />' + Number(entriesArray[i].calories).toFixed(0) + ' Calories</p></a><a id="favSelect" data-favState="true" data-favIndex="'+i+'" class="ui-alt-icon"></a></li>';
            			
            		}else{
            			html = '<li id="selectableCells" style="white-space:normal" data-masterArrayIndex="'+i+'"><a id="itemSelect" href="#addPA" data-masterArrayIndex="'+i+'" data-selectType="search"><p style="font-size:14px;white-space:normal;"><b>' + entriesArray[i].desc + '</b></p><p>' + entriesArray[i].duration + ' Minutes<br />' + Number(entriesArray[i].calories).toFixed(0) + ' Calories</p></a><a id="favSelect" data-favState="false" data-favIndex="'+i+'"></a></li>';
            		}
            			
            			this.$("#addActivity").after(html);
            			paCalorieTotal = Number(paCalorieTotal) + Number(entriesArray[i].calories);
            	
            	}
            }
            
            this.$("#activityCalories").html(paCalorieTotal.toFixed(0));
            
            
            UserData.set('activityCalories', paCalorieTotal.toFixed(0));
            UserData.save();
            
            var today = new Date(UserData.get('entryDate'));
            today = today.toDateString();
            
            var todayMinus1 = new Date(UserData.get('entryDate'));
            todayMinus1.setHours(-24);
            todayMinus1 = todayMinus1.toDateString();
            
            var todayMinus2 = new Date(UserData.get('entryDate'));
            todayMinus2.setHours(-48);
            todayMinus2 = todayMinus2.toDateString();
            
            var todayMinus3 = new Date(UserData.get('entryDate'));
            todayMinus3.setHours(-72);
            todayMinus3 = todayMinus3.toDateString();
            
            var todayMinus4 = new Date(UserData.get('entryDate'));
            todayMinus4.setHours(-96);
            todayMinus4 = todayMinus4.toDateString();
            
            var todayMinus5 = new Date(UserData.get('entryDate'));
            todayMinus5.setHours(-120);
            todayMinus5 = todayMinus5.toDateString();
            
            var todayMinus6 = new Date(UserData.get('entryDate'));
            todayMinus6.setHours(-144);
            todayMinus6 = todayMinus6.toDateString();
            
            var todayMinus7 = new Date(UserData.get('entryDate'));
            todayMinus7.setHours(-168);
            todayMinus7 = todayMinus7.toDateString();

            var str = 0, str1 = 0, str2 = 0, str3 = 0, str4 = 0, str5 = 0, str6 = 0, str7 = 0;
            
            var flex = 0;
            var aero = 0;
            var steps = 0;
            
            var stepsArray = PAData.get("stepEntrys");
            
            
            for (var i=0;i<stepsArray.length; i++){
            	if(today == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus1 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus2 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus3 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus4 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus5 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	if(todayMinus6 == stepsArray[i].date){
            		steps = Number(steps) + Number(stepsArray[i].steps);
            	}
            	
            	// if(todayMinus7 == stepsArray[i].date){
            		// steps = Number(steps) + Number(stepsArray[i].steps);
            	// }
            	
            }
            
            for (var i=0;i<entriesArray.length; i++){
            	
            	if(today == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str = 1;
            		}
            	}
            	
            	if(todayMinus1 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str1 = 1;
            		}
            	}
            	
            	if(todayMinus2 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str2 = 1;
            		}
            	}
            	
            	if(todayMinus3 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str3 = 1;
            		}
            	}
            	
            	if(todayMinus4 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str4 = 1;
            		}
            	}
            	
            	if(todayMinus5 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str5 = 1;
            		}
            	}
            	
            	if(todayMinus6 == entriesArray[i].dateOfActivity){
            		
            		if(entriesArray[i].aerobic == true){
            		aero = Number(aero) + Number(entriesArray[i].duration);
            		}
            		
            		if(entriesArray[i].flexibility == true){
            		flex = Number(flex) + Number(entriesArray[i].duration);
            		}

            		if(entriesArray[i].strength == true){
            			str6 = 1;
            		}
            	}
            	
            	// if(todayMinus7 == entriesArray[i].dateOfActivity){
//             		
            		// if(entriesArray[i].aerobic == true){
            		// aero = Number(aero) + Number(entriesArray[i].duration);
            		// }
//             		
            		// if(entriesArray[i].flexibility == true){
            		// flex = Number(flex) + Number(entriesArray[i].duration);
            		// }
// 
            		// if(entriesArray[i].strength == true){
            			// str7 = 1;
            		// }
            	// }
            }
            
            var strengthTotal = str + str1 + str2 + str3 + str4 + str5 + str6 + str7;
            
            console.log("aerobic: " + aero + " | Strength: " + strengthTotal + " | Flexibility: " + flex);
            this.$("#aerobicMin").html(aero);
            this.$("#strengthDays").html(strengthTotal);
            this.$("#fexibilityMin").html(flex);
            this.$("#stepsNumber").html(steps);

            return this;
		},
        getIndex: function(ev){

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index() - 1;

        	console.log("selected index: " + selected_index);


        },
        refreshList: function(){

        	console.log('refresh');
        	
        	this.$('#foodList').listview('refresh');

        	
        },
		favTappedInList:function(ev){
				
			favorite = false;
			
			for(var i=0;i < favArray.length;i++){
				if(entriesArray[$(ev.currentTarget).attr("data-favIndex")].desc === favArray[i].Desc){
					favorite = true;
				}
			}
			
			if(favorite == true){
				for(var i=0;i<favArray.length;i++){
					if(entriesArray[$(ev.currentTarget).attr("data-favIndex")].desc === favArray[i].Desc){
        		favorite = false;
        		favArray.splice(i,1);
        	}
        }
				
			}else{
					
				favArray[favArray.length]={Desc: entriesArray[$(ev.currentTarget).attr("data-favIndex")].desc,METS: entriesArray[$(ev.currentTarget).attr("data-favIndex")].mets, favorite: true};
				favorite = true;
				
			}
			
			favorite = false;
			
			PAData.set("PAFavorites",favArray);
			PAData.save();
			
			this.render();
			
			$('body').enhanceWithin();
			
		},
		itemTappedInList:function(ev){
			
			
			console.log(JSON.stringify(entriesArray[$(ev.currentTarget).attr("data-masterArrayIndex")]));
			console.log($(ev.currentTarget).attr("data-masterArrayIndex"));
			UserData.set("isEditing", true);
			UserData.set("editingObject",entriesArray[$(ev.currentTarget).attr("data-masterArrayIndex")]);
			UserData.set("editIndex",$(ev.currentTarget).attr("data-masterArrayIndex"));
			
			UserData.save();
			
		}

    });

    return PAListView;
});
