define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        GuidesCollection = require("collections/allGuides"),
        pdfHelper = require("views/pdfHelperFunctions"),
        template = require("text!templates/resourceList.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    ResourceListView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "resourceListView",

        initialize: function(args) {
        	        	
        	if (args.id) {
            	this.model = GuidesCollection.get(args.id);
            	this.model.set ("preText", "Tap below to select key handouts from from the MOVE! website that go along with this Guide:");
            	this.model.set ("postText", "For additional information, look under \"How to Solve Problems\" -> \"Find Resources\" or contact your health care provider.");
            	this.model.set ("isResources", "true");
            	GuidesCollection.get(args.id).save("resourcesComplete", "check");
            	
           } else {
           	
           		this.model = new Backbone.Model(args);
           		
           }
        },

		events: {
             "click #resourceListItem": "listItemTapped"
		},

        render: function() {
        	
        	console.log ("model in render method: \n" + JSON.stringify(this.model) + "\n\n");
        	
        	$(this.el).html(compiled_template(this.model.toJSON()));

            return this;
        },

       	// is there a way to call this from the events section rather than doing this?
        listItemTapped: function (event) {
			pdfHelper.openHandoutsPDF(event);
        }

    });

    return ResourceListView;
});
