define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/shakeGame.html");

    var compiled_template = Handlebars.compile(template);

	var save_this = this;

    var ShakeGameView = Backbone.View.extend({
        id: "shakeGameView",

        templateName: "shakeGame.html",

         events: {
             "click #shake-button": "handleShakeButton"  // this is for the button click
         },

		initialize: function() {
			console.log ("initializing shake game view: " + this);


			/* -- cordova plugin add https://github.com/leecrossley/cordova-plugin-shake-detection.git
				var onShake = function () {
				  // Code fired when a shake is detected
				};

				// Start watching for shake gestures and call "onShake"
				shake.startWatch(onShake);

				// Stop watching for shake gestures
				shake.stopWatch();
			*/
			var that = this;

			var shakeIt = function() {
				console.log("shakeIt event occurred");

				console.log("this: " + this);
				console.log("that: " + that);

				shake.stopWatch();  // seems to reset automatically after handling each shake

				// TODO: i'd like to call the handleShakeButton() function but trouble referencing it.
				console.log("stopped");
				console.log("this: " + this);
				console.log("that: " + that);

				var nextWord = that.model.nextWord();
				console.log("nextWord: " + nextWord);

				var nextButton = that.model.nextButton();
				console.log("nextButton: " + nextButton);

				//ask the model for a word, let it worry about keeping track of stuff
				that.$('#shake-text').html(nextWord);
				that.$('#shake-button').html(nextButton);
			};

			if (typeof shake != "undefined") {
				shake.startWatch(shakeIt);
			}

			// when to end?



		},

        render: function() {

        	log.debug ("calling render in shake view with template name: " + this.templateName);

        	this.shakeTemplate = compiled_template(this.model);

            this.$el.html(compiled_template(this.model));
            return this;
        },

        handleShakeButton: function() {
			console.log("shake button tapped: " + this);

      		//ask the model for a word, let it worry about keeping track of stuff
      		this.$('#shake-text').html(this.model.nextWord());
      		this.$('#shake-button').html(this.model.nextButton());
        },

        handleShake: function() {  // this function loses context when called this way
			console.log("x handleshake event occurred:" + this);

			var nextWord = this.model.nextWord();
			console.log("nextWord: " + nextWord);
console.log("save_this: " + save_this);

var that = this;
shake.stopWatch();
console.log("this: " + this);
      		//ask the model for a word, let it worry about keeping track of stuff
      		save_this.$('#shake-text').html(nextWord);
         }
    });

    return ShakeGameView;
});
