define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        NutritionData = require("models/NutritionData"),
        PAData = require("models/PAData"),
        WeightModel = require("models/WeightModel"),
        WeightsCollection = require('collections/weightsCollection'),
        MCM_Keyboard_Plugin = require("plugin/MCM_Keyboard_Plugin"),
        template = require("text!templates/SingleCustomTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var dateEntered;

	var PortionArray = [];
	var NutritionArray = [];
	var favArray = [];
	var customArray = [];
	
	var selectedFood;
	var selectedPortion;
	
	var food_index;
	var portion_index;
	
	var hungerMood = false;
	
	var mindful = false;
	var	portionControlled = false;
	var	healthy = false;
	
	var textString = 1.0;


    var SingleCustomView = Backbone.View.extend({
        id: "SingleCustomView",

        templateName: "SingleCustomTemplate.html",

           events: {


            "click #doneButton": "doneButtonTapped"
           

           },

initialize: function() {
			console.log ("initializing singleCustom view: " + this);
			
			this.collection = new WeightsCollection();

		},

		render: function() {
			log.debug ("calling render in singleCustom view with template name: " + this.templateName);

        	
        	this.$el.html(template);

            textString = "";
            
            // this.$("#mealTitle").html(UserData.get("selectedMeal"));
            
            console.log("current weight from collection: " + this.collection.getCurrentWeight().get("weight"));
            
            if(UserData.get("singleCustomType") == "food"){
            	this.$("#customActivityEntry").hide();
            }else{
            	this.$("#customFoodEntry").hide();
            	// this.$("#doneButton").replaceWith('<a href="#addPA" id="doneButton" class="back ui-btn-right ios7Button" data-role="none" data-rel="back" data-direction="reverse">Done</a>');
            	if(UserData.get("customEditIndex") >= 0){
            		customArray = PAData.get("customPA");
            		this.$("#activityTitle").val(customArray[UserData.get("customEditIndex")].Desc);
            		var editDuration = customArray[UserData.get("customEditIndex")].duration;
            		
            		
            		var hours = Math.trunc(Number(editDuration) / 60);
        			var min = Number(editDuration) - (Number(hours) * 60);
        	
        			this.$("#hrSelect").val(hours);
        			this.$("#minSelect").val(min);
        			
        			this.$("#customCaloriesBurned").val(customArray[UserData.get("customEditIndex")].calories);
            		
            	}

            }
            
            
            
			// this.$('#doneButton').addClass("ui-state-disabled");
		  
           

            return this;
		},
		doneButtonTapped: function(){
			
			
			
			var code = new Date();
				code = code.getTime();
			
			var entryDate = UserData.get("entryDate").toDateString();
				
			if(UserData.get("singleCustomType") == "food"){
				
				
				
            	var customFood = {
                		foodcode: code,
                		foodname: this.$("#customTitle").val(),                 		
                		Portion_Factor: 1,
                		portiondesc: this.$("#customServingSize").val(),
                		energy: this.$("#customCaloriesPerServing").val()                		                		
            };
            	
            	
            	console.log(JSON.stringify(customFood));
            	
            }else{
            	
            	var activityDesc = this.$("#activityTitle").val();
            	
            	var hours = this.$("#hrSelect").val();
			
			var minutes = this.$("#minSelect").val();
			
			var duration = (Number(hours) * 60) + Number(minutes);
                	
            	// var duration = this.$("#customDuration").val();
            	var caloriesBurned = this.$("#customCaloriesBurned").val();
            	
            	var caloriesPerMin = Number(caloriesBurned) / Number(duration);
            	
            	var mets = (Number(caloriesPerMin) * 200) / (3.5 * (Number(this.collection.getCurrentWeight().get("weight")) * 0.4535924));
            	
			
			var customActivity = {
				compcode: code,
				Desc: activityDesc,
				METS: mets,
				duration: duration,
				caloriesPerMin: caloriesPerMin,
				calories: caloriesBurned,
				dateOfActivity: entryDate,
				aerobic: false,
				strength: false,
				flexibility: false
			};
			
			var customPAArray = [];
			
			customPAArray = PAData.get("customPA");
			
			var favArray = [];
			favArray = PAData.get("PAFavorites");
			
			if(UserData.get("customEditIndex") >= 0){
				
				if(favArray.length > 0){
  						
				var favIndex = -1;
				for (var i = 0; i<favArray.length;i++){
					
					if(customPAArray[UserData.get("customEditIndex")].Desc == favArray[i].Desc){
						favIndex = i;
					}
					
				}
				
				if(favIndex > -1){
					favArray.splice(favIndex,1);
				}
			

	  					PAData.set("PAFavorites",favArray);
					}
				
				
				customPAArray.splice(UserData.get("customEditIndex"),1,customActivity);
			}else{
				customPAArray[customPAArray.length] = customActivity;
			}
			
			UserData.set("customEditIndex",-1);
			
			PAData.set("customPA",customPAArray);
			
			console.log(JSON.stringify(customActivity));
			
			var PAEntryArray = [];
			
			PAEntryArray = PAData.get("PAEntrys");
			
			
			
			
			favArray[favArray.length]={Desc: customActivity.Desc,METS: customActivity.METS, favorite: true};
			
			// console.log(JSON.stringify(entriesArray[$(ev.currentTarget).attr("data-masterArrayIndex")]));
			// console.log($(ev.currentTarget).attr("data-masterArrayIndex"));

			
			
			
			var that=this;
			var titleString = "New activity '" + customActivity.Desc +"' created.\nWould you like to add this activity to " + entryDate + "?";
			
			function onConfirm(buttonIndex) {
				console.log("buttonIndex: " + buttonIndex);
  				if (buttonIndex === 1) {
  					// NO
  					// PAEntryArray.splice(PAEntryArray[PAEntryArray.length - 1],1);
  					
		
	  					// PAData.set("PAEntrys",PAEntryArray);
						PAData.save();
						
						

					}else{
						// YES
						
						if(!PAEntryArray){
				PAEntryArray[0]={desc: customActivity.Desc, mets: customActivity.METS, duration: duration, caloriesPerMin: caloriesPerMin, calories:caloriesBurned, dateOfActivity: entryDate, aerobic: customActivity.aerobic, strength: customActivity.strength, flexibility: customActivity.flexibility};
			}else{
				PAEntryArray[PAEntryArray.length]={desc: customActivity.Desc, mets: customActivity.METS, duration: duration, caloriesPerMin: caloriesPerMin, calories:caloriesBurned, dateOfActivity: entryDate, aerobic: customActivity.aerobic, strength: customActivity.strength, flexibility: customActivity.flexibility};	
			}
			
			PAData.set("PAEntrys",PAEntryArray);
			PAData.set("selectedPA",PAEntryArray[PAEntryArray.length - 1]);
			
						UserData.set("isEditing", true);
			UserData.set("editingObject",PAEntryArray[PAEntryArray.length - 1]);
			UserData.set("editIndex",  (PAEntryArray.length - 1));
			
					
						PAData.save();
						// PAEntryArray.splice(PAEntryArray[PAEntryArray.length - 1],1);
  					
		
	  					// PAData.set("PAEntrys",PAEntryArray);
						// PAData.save();
					}
  					UserData.save();
  					
  			// that.render();
  					// Backbone.history.loadUrl();	
  						Backbone.history.history.back();

				};
			
			
			
			navigator.notification.confirm(
    			' ', // message
     			onConfirm,            // callback to invoke with index of button pressed
    			titleString,           // title
    			['No','Yes']     // buttonLabels
			);
			
			
			
			
            }
		}
        
    });

    return SingleCustomView;
});
