define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/summaryStatus.html"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);

	var SummaryStatusView = Backbone.View.extend({
        id: "summaryStatusView",

        templateName: "summaryStatus.html",

           events: {


           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);



		},

		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);

        	//do we need both these lines?
        	//this.videoTemplate = compiled_template(this.model);

            this.$el.html(compiled_template(this.model.toJSON()));

            var height = Number(UserData.get("initialHeight"));

            var curWt = Number(UserData.get("currentWeight"));

            var baseWt = Number(UserData.get("initialWeight"));

            var calcBMI = ((curWt) / (height * height)) * 703.0;

            var calcWtLoss = Number(baseWt) - Number(curWt);

            var calcWtLossPercent = (Number(calcWtLoss) / Number(baseWt)) * 100;

            var calGoal = UserData.get("dailyCalorieGoal");

            var calUsed = 0.0;
            var calBurn = 0.0;

            var calBal = (Number(calGoal) - calUsed) + calBurn;


            calcBMI = calcBMI.toFixed(1);
            calcWtLoss = calcWtLoss.toFixed(1);
            calcWtLossPercent = calcWtLossPercent.toFixed(1);

            UserData.set("bodyMassIndex", calcBMI);
            UserData.set("weightLost", calcWtLoss);
            UserData.set("percentWeightLost",calcWtLossPercent);

            UserData.save();

            this.$("#calBalance").replaceWith('<span id="calBalance" class="ui-li-aside" style="margin-right: -40px;">' + calBal + ' Cal</span>');
            this.$("#weightLoss").replaceWith('<span id="weightLoss" class="ui-li-aside" style="margin-right: -40px;">' + calcWtLoss + 'lbs./' + calcWtLossPercent + '%</span>');

            if(Number(calcBMI) < 18.5){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(196,217,224); margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else if(Number(calcBMI) >= 18.5 && Number(calcBMI) < 25){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(153,200,112); margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else if(Number(calcBMI) >= 25 && Number(calcBMI) < 30){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(253,227,148); margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else if(Number(calcBMI) >= 30 && Number(calcBMI) < 35){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(224,113,155); margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else if(Number(calcBMI) >= 35 && Number(calcBMI) < 40){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(227,114,35); margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else if(Number(calcBMI) >= 40){
            	this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="background-color: rgb(207,28,32); color: white; margin-right: -40px;"><b style="text-shadow: none;">&nbsp;' + calcBMI + '&nbsp;</b></span>');
            }else{
            this.$("#bmi").replaceWith('<span id="bmi" class="ui-li-aside" style="margin-right: -40px;">' + calcBMI + '</span>');
            }
            // if(UserData.firstTimeEntriesComplete !== true){
				// $('#headerText').html("Please enter the following:");
			// }else{
				// $('#headerText').html("Welcome to MOVE! Coach, the following entries are required.");
			// }
//
            return this;
		}
	});
	return SummaryStatusView;
});
