define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/weightLossGoal.html"),
        WeightLossTargetEntryView = require("views/WeightLossTargetEntryView"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);
    
    var curWt = 0.0;
    
    
    var handoutTap = false;
    var chapterTap = false;
//     
    var rateValue = 0.5;
    var rateText = "";
    var mcaValue = 0;
    
    var percentToLose = 0.0;
    var targetWeight = 0.0;
    var poundsToLose = 0.0;
    
    if(UserData.get('mcaValue')){
    	mcaValue = UserData.get('mcaValue');
    }
    
    var mcaText = "";
    var calorieGoalValue = 1200;
    var calorieGoalText = "";
    var dateGoalReached = new Date();
    
	var WeightLossGoalView = Backbone.View.extend({
        id: "weightLossGoalView",

        templateName: "weightLossGoal.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
              // "change #joinedMOVE1": "saveJoinedMOVEData",
              // "change #joinedMOVE2": "saveJoinedMOVEData",
              // "change #MOVE_Hope1": "saveJoinedMOVEData",
              // "change #MOVE_Hope2": "saveJoinedMOVEData"  
              // "change #genderSwitch": "saveUserInfoData"
           /*   "click #poundsToLose": "poundsSelect",
              "click #percentToLose": "percentSelect",
              "click #targetWeight": "targetSelect",
             */ 
              
           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);
			
			

		},
		
		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);
        	
        	//do we need both these lines?
        	//this.videoTemplate = compiled_template(this.model);
        	
            this.$el.html(compiled_template(this.model.toJSON()));
            
            // if(UserData.firstTimeEntriesComplete !== true){
				// $('#headerText').html("Please enter the following:");
			// }else{
				// $('#headerText').html("Welcome to MOVE! Coach, the following entries are required.");
			// }
// 			

			
			 
            if (!(UserData.get("currentWeight"))){
        		curWt = UserData.get("initialWeight");
        		UserData.set("currentWeight",curWt);
   		     }else{
        		curWt = UserData.get("currentWeight");
        	}
            
             
            percentToLose = 5.0;
            
            if(UserData.get("initialPercentToLose")){
            	percentToLose = UserData.get("initialPercentToLose");
            }else{
            	UserData.set("initialPercentToLose", percentToLose);
            }
     		
    	 	poundsToLose = Number(curWt) * (Number(percentToLose) / 100.0);
    	 	
    		targetWeight = Number(curWt) - poundsToLose;
    		
    		percentToLose = Number(percentToLose).toFixed(1);
			poundsToLose = Number(poundsToLose).toFixed(1);
			targetWeight = Number(targetWeight).toFixed(1);
            
            UserData.set("initialLBSToLose", poundsToLose);
             UserData.set("initialTargetWeight", targetWeight);
             
           
            
            UserData.save();
 			
 			this.$('#percentToLoseValue').replaceWith("<span id='percentToLoseValue'>" + percentToLose + "</span>");
 			this.$('#poundsToLoseValue').replaceWith("<span id='poundsToLoseValue'>" + poundsToLose + "</span>");
 			this.$('#targetWeightValue').replaceWith("<span id='targetWeightValue'>" + targetWeight + "</span>"); 

            return this;
		} 
	});
	return WeightLossGoalView;
});