define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/weightLossRateEntry.html");

        var compiled_template = Handlebars.compile(template);

        var textString = "0";

        if (UserData.get("initialWeightLossRange")){
        	textString = UserData.get("initialWeightLossRange");
        }


        //

    return Backbone.View.extend({
        id: "weightLossRateEntryView",

        templateName: "weightLossRateEntry.html",

           events: {

              "click #doneButton": "rateSelect",
              "change #rateSelect": "changeRate"

           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);



		},

        render: function() {
            this.$el.html(template);

            this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5">1/2 lb./Week</option>\
				<option value="1.0">1 lb./Week</option>\
				<option value="1.5">1-1/2 lbs./Week</option>\
				<option value="2">2 lbs./Week</option>\
			</select>');

			if (textString === "0") {
				this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0" selected="selected">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5">1/2 lb./Week</option>\
				<option value="1.0">1 lb./Week</option>\
				<option value="1.5">1-1/2 lbs./Week</option>\
				<option value="2">2 lbs./Week</option>\
			</select>');
			}else if (textString === "0.5") {
				this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5" selected="selected">1/2 lb./Week</option>\
				<option value="1.0">1 lb./Week</option>\
				<option value="1.5">1-1/2 lbs./Week</option>\
				<option value="2">2 lbs./Week</option>\
			</select>');
			}else if (textString === "1.0") {
				this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5">1/2 lb./Week</option>\
				<option value="1.0" selected="selected">1 lb./Week</option>\
				<option value="1.5">1-1/2 lbs./Week</option>\
				<option value="2">2 lbs./Week</option>\
			</select>');
			}else if (textString === "1.5") {
				this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5">1/2 lb./Week</option>\
				<option value="1.0">1 lb./Week</option>\
				<option value="1.5" selected="selected">1-1/2 lbs./Week</option>\
				<option value="2">2 lbs./Week</option>\
			</select>');
			}else if (textString === "2.0") {
				this.$('#rateSelect').replaceWith('<select name="rateSelect" id="rateSelect">\
				<option value="0">Maintain Weight (0 lbs./Week)</option>\
				<option value="0.5">1/2 lb./Week</option>\
				<option value="1.0">1 lb./Week</option>\
				<option value="1.5">1-1/2 lbs./Week</option>\
				<option value="2" selected="selected">2 lbs./Week</option>\
			</select>');
			}

/*            this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');

			if(ftString === "3"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3" selected="selected">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "4"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4" selected="selected">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "5"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5" selected="selected">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "6"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6" selected="selected">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "7"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7" selected="selected">7 ft</option></select>');
			}*/


            return this;
        },
        rateSelect: function(){
			// var percentValue = this.$('#percentInput').val();;
			var rateValue = textString;

			// calorie calculations
			var baselineWeight = UserData.get("initialWeight");

			var minGoal = 1200;
   			 var maxGoal = 3500;
   			 var goalCal = 1200;

 			   var currentWeight = Number(baselineWeight);
 		   var lossRate = Number(rateValue);
//
    // var lossRate = UserData.get("initialWeightLossRange");
//
    if (currentWeight < 200) {
        minGoal = 1200;
        maxGoal = 1500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 226) {
        minGoal = 1500;
        maxGoal = 1800;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 251) {
        minGoal = 1800;
        maxGoal = 2000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 301) {
        minGoal = 2000;
        maxGoal = 2500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 351) {
        minGoal = 2500;
        maxGoal = 3000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else {
        minGoal = 3000;
        maxGoal = 3500;
        goalCal = minGoal + ((maxGoal - minGoal)*(lossRate/2));
    }

    if(UserData.get("mcaValue")){
    goalCal = Number(goalCal) + Number(UserData.get("mcaValue"));
    }
   			// var rateValue = textString;
   			// UserData.save();
   			// var goalCal = UserData.calculateCalorieGoal();

   			console.log("goalCal: " + goalCal);

			this.$('#dailyCalorieGoalValue').html(goalCal);

			// date calculations
			var numberOfDays = 0;

			if(rateValue > 0){
				numberOfDays = (Number(UserData.get("initialLBSToLose")) / rateValue) * 7;
			}

			var targetDate = new Date();
			targetDate.setDate(targetDate.getDate() + numberOfDays);

			var dd = targetDate.getDate();
			var mm = targetDate.getMonth();
			var yyyy = targetDate.getFullYear();

			var months = ["January","February","March","April","May","June","July","August","September","October","November","December"];

			var dateString = months[mm] + " " + dd + ", " + yyyy;

			goalCal = Number(goalCal).toFixed(0);
			// set and save
			UserData.set("initialWeightLossRange", rateValue);
             UserData.set("goalReachedDate", dateString);
             UserData.set("dailyCalorieGoal", goalCal);

             UserData.save();
		},
		changeRate: function(){
			textString = this.$("#rateSelect").val();

			// UserData.set("initialWeightLossRange", rateValue);
			// UserData.save();
		}
    });
});
