define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/weightLossRateWithCal.html"),
        CalendarModel = require("models/CalendarEventModel"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);
    
	var calEventTitle = "MOVE!Coach Weight Goal Check";
	var calEventNotes = "movecoachmobile://weightGoalEvent";


    var rateValue = 0;
    var rateText = "";
    var mcaValue = 0;
    
    if(UserData.get('mcaValue')){
    	mcaValue = UserData.get('mcaValue');
    }
    
    var mcaText = "";
    var calorieGoalValue = 1200;
    var calorieGoalText = "";
    var dateGoalReached = new Date();
    
	var WeightLossRateWithCalView = Backbone.View.extend({
        id: "weightLossRateWithCalView",

        templateName: "weightLossRateWithCal.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
              // "change #joinedMOVE1": "saveJoinedMOVEData",
              // "change #joinedMOVE2": "saveJoinedMOVEData",
              // "change #MOVE_Hope1": "saveJoinedMOVEData",
              // "change #MOVE_Hope2": "saveJoinedMOVEData"  
              // "change #genderSwitch": "saveUserInfoData"
              // "click #weightLossRate": "weightLossRateSelect",
              // "click #calorieAdjust": "adjustCaloriesSelect",
              "click #calendarCell": "calendarSelect",
              
              
           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);
			// console.log("initialWeightLossRange: " + UserData.get("initialWeightLossRange") + " | dailyCalorieGoal: " + UserData.get("dailyCalorieGoal"));
		},
		
		render: function() {
			console.log ("calling render in userInfo view with template name: " + this.templateName);
        	
            this.$el.html(compiled_template(this.model.toJSON()));
            
            
			if (UserData.get("previousGoalReachedDate"))
			{
			    this.$('#calendarCell').html('<h2>Tap to update your calendar</h2><p style="white-space: normal">The existing event in your device calendar will be updated</p>');
			}
            
            
            mcaValue = UserData.get("mcaValue");
            
            if(Number(UserData.get("mcaValue")) > 49 || Number(UserData.get("mcaValue")) < -1){
            	this.$('#mcaText').replaceWith('<p id="mcaText">Includes ' + mcaValue + ' Calorie adjustment</p>');
            }else{
            	this.$('#mcaText').replaceWith('<p id="mcaText">Tap to adjust Calorie goal</p>');
            }
            // if(UserData.firstTimeEntriesComplete !== true){
				// $('#headerText').html("Please enter the following:");
			// }else{
				// $('#headerText').html("Welcome to MOVE! Coach, the following entries are required.");
			// }
// 			
			
            if (!(UserData.get("currentWeight"))){
        		curWt = UserData.get("initialWeight");
        		UserData.set("currentWeight",curWt);
   		     }else{
        		curWt = UserData.get("initialWeight");
        	}
            
            if(!(UserData.get("initialWeightLossRange"))){
            	rateValue = 0.5;
            	UserData.set("initialWeightLossRange", rateValue);
            }else{
            	rateValue = UserData.get("initialWeightLossRange");
            }
            
            if(!(UserData.get("mcaValue"))){
            	mcaValue = 0;
            }else{
            	mcaValue = UserData.get("mcaValue");
            }
            
            calorieGoalValue = UserData.calculateCalorieGoal(rateValue,UserData.get("currentWeight"));
            
            if(Number(UserData.get("mcaValue")) > 10 || Number(UserData.get("mcaValue")) < -10){
            	this.$('#mcaText').replaceWith('<p id="mcaText">Includes ' + mcaValue + ' Calorie adjustment</p>');
            	calorieGoalValue = Number(calorieGoalValue) + Number(mcaValue);
            }else{
            	this.$('#mcaText').replaceWith('<p id="mcaText">Tap to adjust Calorie goal</p>');
            	UserData.set("mcaValue", mcaValue);
            }
            
            UserData.set("dailyCalorieGoal", calorieGoalValue);
            
            percentToLose = 5.0;
            
            if(UserData.get("initialPercentToLose")){
            	percentToLose = UserData.get("initialPercentToLose");
            }else{
            	UserData.set("initialPercentToLose", percentToLose);
            }
     		
    	 	poundsToLose = Number(curWt) * (Number(percentToLose) / 100.0);
    	 	
    		targetWeight = Number(curWt) - poundsToLose;
    		
    		percentToLose = Number(percentToLose).toFixed(1);
			poundsToLose = Number(poundsToLose).toFixed(1);
			targetWeight = Number(targetWeight).toFixed(1);
            
            UserData.set("initialLBSToLose", poundsToLose);
             UserData.set("initialTargetWeight", targetWeight);
             
             
             // date calculations
			var numberOfDays = 0;
			
			if(rateValue > 0){
				numberOfDays = (Number(poundsToLose) / Number(rateValue)) * 7;
			}
			
			var targetDate = new Date();
			targetDate.setDate(targetDate.getDate() + numberOfDays);
			
			var dd = targetDate.getDate();
			var mm = targetDate.getMonth();
			var yyyy = targetDate.getFullYear();
			
			var months = ["January","February","March","April","May","June","July","August","September","October","November","December"];
			
			var dateString = months[mm] + " " + dd + ", " + yyyy;
 
             UserData.set("goalReachedDate", dateString);
           
            
            UserData.save();
 			
 			// this.$('#percentToLoseValue').replaceWith("<span id='percentToLoseValue'>" + percentToLose + "</span>");
 			// this.$('#poundsToLoseValue').replaceWith("<span id='poundsToLoseValue'>" + poundsToLose + "</span>");
 			// this.$('#targetWeightValue').replaceWith("<span id='targetWeightValue'>" + targetWeight + "</span>");
 			// this.$('#currentWeightValue').replaceWith("<span id='currentWeightValue'>" + curWt + "</span>");
 			
 			this.$('#weightLossRateValue').replaceWith('<span id="weightLossRateValue">' + rateValue + '</span>');
 			this.$('#dailyCalorieGoalValue').replaceWith('<span id="dailyCalorieGoalValue">' + calorieGoalValue + '</span>');
 			this.$('#dateGoalReached').replaceWith("<span id='dateGoalReached'>" + dateString + "</span>");
 			
            return this;
		},
		weightLossRateSelect: function(){
			// var rateValue = prompt('Enter the rate at which you would like to lose weight (lbs. per week)');
			
			// calorie calculations
			var baselineWeight = UserData.get("initialWeight");
			
			var minGoal = 1200;
   			 var maxGoal = 3500;
   			 var goalCal = 1200;
    
 			   var currentWeight = Number(baselineWeight);
 		   // var lossRate = Number(rateValue);
//     
    // var lossRate = UserData.get("initialWeightLossRange");
//     
    if (currentWeight < 200) {
        minGoal = 1200;
        maxGoal = 1500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 226) {
        minGoal = 1500;
        maxGoal = 1800;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 251) {
        minGoal = 1800;
        maxGoal = 2000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 301) {
        minGoal = 2000;
        maxGoal = 2500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 351) {
        minGoal = 2500;
        maxGoal = 3000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else {
        minGoal = 3000;
        maxGoal = 3500;
        goalCal = minGoal + ((maxGoal - minGoal)*(lossRate/2));
    }
    
    if(UserData.get("mcaValue")){
    goalCal = Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight"))) + Number(UserData.get("mcaValue"));
    }
			
			this.$('#dailyCalorieGoalValue').html(goalCal);
			
			// date calculations
			// SJB - where is rateValue set?
			var numberOfDays = Number(UserData.get("initialLBSToLose")) / rateValue;
			
			var targetDate = new Date();
			targetDate.setDate(targetDate.getDate() + numberOfDays);
			console.log("***** targetDate for weight loss: " + targetDate);

			var dd = targetDate.getDate();
			var mm = targetDate.getMonth();
			var yyyy = targetDate.getFullYear();
			
			var months = ["January","February","March","April","May","June","July","August","September","October","November","December"];
			
			var dateString = months[mm] + " " + dd + ", " + yyyy;
			
			goalCal = Number(goalCal).toFixed(0);
			// set and save
			 UserData.set("initialWeightLossRange", rateValue);
             UserData.set("goalReachedDate", dateString);
             UserData.set("dailyCalorieGoal", goalCal);
             
             UserData.save();
             console.log("weightLossRateSelect finished");
		},
		
		adjustCaloriesSelect: function(){
			var adjustCaloriesValue = prompt('Enter the number of calories you would like to adjust your calorie goal by');
			var baselineWeight = UserData.get("initialWeight");
			
			var minGoal = 1200;
   			 var maxGoal = 3500;
   			 var goalCal = 1200;
    
 			   var currentWeight = Number(UserData.get("currentWeight"));
 		   var lossRate = Number(UserData.get("initialWeightLossRange"));
 		   
//     
    // var lossRate = UserData.get("initialWeightLossRange");
//     
    if (currentWeight < 200) {
        minGoal = 1200;
        maxGoal = 1500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 226) {
        minGoal = 1500;
        maxGoal = 1800;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 251) {
        minGoal = 1800;
        maxGoal = 2000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 301) {
        minGoal = 2000;
        maxGoal = 2500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 351) {
        minGoal = 2500;
        maxGoal = 3000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else {
        minGoal = 3000;
        maxGoal = 3500;
        goalCal = minGoal + ((maxGoal - minGoal)*(lossRate/2));
    }
    
    goalCal = Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight"))) + Number(adjustCaloriesValue);
    
			console.log("current Weight: " + currentWeight + " | loss Rate: " + lossRate + " | cal goal: " + goalCal + " | adjustvalue: " + adjustCaloriesValue);
			
			
			var mcaText = "Tap to set Medical Calorie Adjustment";

			if (adjustCaloriesValue !== 0){
				mcaText = "Includes Medical Calorie Adjustment of " + adjustCaloriesValue + " Calories";
			}
			
			goalCal = Number(goalCal).toFixed(0);
			
			 UserData.set("mcaValue", adjustCaloriesValue);
             UserData.set("medicalCalorieAdjustmentText", mcaText);
             UserData.set("dailyCalorieGoal", goalCal);             
             
             UserData.save();
		},
		
		calendarSelect: function(){
			console.log("calendarSelect");
			
			/******
			 * SJB - Here's the logic i'm doing:
			 * 
			 * 1. if the new date is invalid, don't look for a previous one to delete, just return.
			 * 2. if the new date is good, check for a previous date to move (delete) that calendar event.
			 * 3. if no previous date, just send in new one as old date and all is well.
			 * 4. move/create weight checkin event
			 * 5. record new checkin date
			 */

			// 1. if the new date is invalid, don't look for a previous one to delete, just return.
			var checkinDate = new Date(UserData.get("goalReachedDate"));
			if ( isNaN( checkinDate.valueOf() ) ) 
			{
				console.log("invalid weight goal reached checkin date");
				return; 
			} else console.log("valid weight goal reached checkin date");

			// 2. if the new date is good, check for a previous date to move (delete) that calendar event.
			var prevCheckinDate = new Date(UserData.get("previousGoalReachedDate"));
			if ( isNaN( prevCheckinDate.valueOf() ) ) 
			{
				console.log("previous goal reached date is invalid");
				// 3. if no previous date, just send in new one as old date and all is well.
				prevCheckinDate = checkinDate; 
			} else console.log("valid previous goal reached weight checkin date");

			// since no time is associated with goal reached date, 
			// use current time of day because user is awake so should be safe
			var today = new Date();
			checkinDate.setHours( today.getHours() );
			checkinDate.setMinutes( today.getMinutes() );
			checkinDate.setMilliseconds( 0 );
				
			console.log("new checkin date/time: " + checkinDate);

			// 4. do it
			mcmCalendar = new CalendarModel(calEventTitle, calEventNotes);
			mcmCalendar.moveEvent(prevCheckinDate, checkinDate);
			
			// 5. record new checkin date
			UserData.set("previousGoalReachedDate", checkinDate);
			UserData.save();

			// TODO go somewhere, or change field to show event created or ???
            this.$('#calendarCell').html('<h2>Tap to update your calendar</h2><p style="white-space: normal">The existing event in your device calendar will be updated</p>');
// TODO how to update this at the beginning if there's already an event?
			console.log("calendarSelect finished");
			
		}
	});
	return WeightLossRateWithCalView;
});

