define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        WeightCollection = require("collections/allWeights"),
        template = require("text!templates/weight.html");

    var compiled_template = Handlebars.compile(template);

    var WeightView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "weightView",


        collection: WeightCollection,

        events: {
            'click #saveWeight': 'save'
        },

        initialize: function() {
            // _.bindAll(this, 'save');

            this.collection.on('add', this.render, this);
        },

        render: function() {
            this.$el.html(compiled_template(this.collection.toJSON()));

            console.log('%crendering weights', 'color:pink');

            $("body").enhanceWithin();

            return this;
        },

        save: function() {
            var weight = this.$("#newWeight").val();
            var dt = this.$("#newDate").val();
            if (weight && dt) {
                var dt = new Date(dt).toLocaleDateString();

                this.collection.add({
                    "weight": weight,
                    "date": dt
                });
            }
        }
    });

    return WeightView;
});






//
// app.weightForm = Backbone.View.extend({
// events: {
// "click #completedbtn" : 	"complete",
// "click #updatebtn" : 		"update",
// "click #savebtn" : 		"save",
// "click #closebtn" : 		"close",
// },
// render: function() {
// var formString = this.template(this.model.toJSON());
// $(formString).dialog({
// autoOpen: true,
// height: 460,
// width: 350,
// title:"Tasks",
// modal: true
// })
// this.el = $(".dialogForm");
// this.delegateEvents(this.events)
// return this;
// },
// initialize : function(){
// _.bindAll(this,"render")
// this.template = _.template($("#task_form_tpl").html());
// this.render().el;
// },
// complete: function(){
// console.log("test")
// },
// update: function(){
// console.log("test")
// },
// save: function(){
// console.log("test")
// },
// close: function(){
// console.log("test")
// },
// });
